//*******************
// ARToolKitbp[
//*******************

#include	<math.h>	
#include	"ARTK.h"
#include	"../ErrorMes.h"

#define PI       3.14159265358979323846

cARTK		g_clARTK;

//================
// RXgN^
//================
cARTK::cARTK( void ) : m_iCamImgSizeX(0), m_iCamImgSizeY(0), m_pARTImage( NULL ), m_pArglSettings( NULL ), m_bMarkerFound( false )
{
}

//==============
// fXgN^
//==============
cARTK::~cARTK( void )
{
	cleanup();
}

//========
// 
//========
bool cARTK::initialize( void )
{

#ifdef _DEBUG

	// VisualStudiofobO̎ɁAǂ̃tH_[ɂĂ̂Ȃ̂ŁA
	// ΃pXɂČ떂B

	const char	*szCameraParamFName = "C:/Temp/ARTK_MMD_Data/camera_para.dat";
	const char	*szPattFName  = "C:/Temp/ARTK_MMD_Data/patt.00";
#ifdef _WIN32
	char		*szVConfFName = "C:/Temp/ARTK_MMD_Data/WDM_camera_flipV.xml";
#else
	char		*szVConfFName = "";
#endif

//	arDebug = 1; // ARToolkit̃fobOL  main.cpp Ɉړ

#else // _DEBUG

	const char	*szCameraParamFName = "Data/camera_para.dat";
	const char	*szPattFName  = "Data/patt.00";
#ifdef _WIN32
	char		*szVConfFName = "Data/WDM_camera_flipV.xml";
#else
	char		*szVConfFName = "";
#endif

#endif // _DEBUG


	ARParam			sCamParamTemp;
//	int				iCamImgSizeX, // o[ϐ
//					iCamImgSizeY;

	// JfoCX̃I[v
	if( arVideoOpen( szVConfFName ) < 0 )
	{
		ErrorMessage( "Unable to open connection to camera.\n" );
		return false;
	}

	// J摜̃TCY擾
	if( arVideoInqSize( &m_iCamImgSizeX, &m_iCamImgSizeY ) < 0 ) return false;

	// Jp[^t@C̓Ǎ
	if( arParamLoad( szCameraParamFName, 1, &sCamParamTemp ) < 0 )
	{
		ErrorMessage( "Error loading parameter file for camera.\n" );
		arVideoClose();
		return false;
	}

	// Jp[^̃TCYύX
	arParamChangeSize( &sCamParamTemp, m_iCamImgSizeX, m_iCamImgSizeY, &m_sCameraParam );

	// CũJp[^̏
	arInitCparam( &m_sCameraParam );

	// J摜̃Lv`Jn
	if( arVideoCapStart() != 0 )
	{
		ErrorMessage( "Unable to begin camera data capture.\n" );
		arVideoClose();
		return false;
	}

	// }[J[p^[t@C̓Ǎ
    if( (m_iPattID = arLoadPatt( szPattFName )) < 0 )
    {
		ErrorMessage( "Pattern file load error !!\n" );
		arVideoCapStop();
		arVideoClose();
		return false;
    }

	m_uiARTImageSize = sizeof(ARUint8) * m_iCamImgSizeX * m_iCamImgSizeY * 4;
	m_pARTImage      = (ARUint8 *)malloc( m_uiARTImageSize );
	memset( m_pARTImage, 0, m_uiARTImageSize );

	m_dViewScaleFactor =  0.16;
	m_dPattWidth       = 40.0;
	m_bFirstTime       = true;

	return true;
}

//==============
// argl̏
//==============
bool cARTK::initArgl( void )
{
	// arglOpenGĽ݂̃ReLXgpɃZbgAbv
	if( (m_pArglSettings = arglSetupForCurrentContext()) == NULL )
	{
		ErrorMessage( "arglSetupForCurrentContext() returned error.\n" );
		arVideoCapStop();
		arVideoClose();
		return false;
	}

#if 0
	double	c = cos( PI * 0.5 );
	double	s = sin( PI * 0.5 );
	m_dmatRotX[ 0] = 1.0; m_dmatRotX[ 1] = 0.0; m_dmatRotX[ 2] = 0.0; m_dmatRotX[ 3] = 0.0;
	m_dmatRotX[ 4] = 0.0; m_dmatRotX[ 5] =   c; m_dmatRotX[ 6] =   s; m_dmatRotX[ 7] = 0.0;
	m_dmatRotX[ 8] = 0.0; m_dmatRotX[ 9] =  -s; m_dmatRotX[10] =   c; m_dmatRotX[11] = 0.0;
	m_dmatRotX[12] = 0.0; m_dmatRotX[13] = 0.0; m_dmatRotX[14] = 0.0; m_dmatRotX[15] = 1.0;
#endif

	MatrixRotationX( m_matModelViewRotX,  PI * 0.5f ); // X+90x]
	MatrixRotationX( m_matCameraRotX,    -PI * 0.5f ); // X-90x]

	return true;
}

//==================
// }[J[o
//==================
bool cARTK::update( void )
{
	ARUint8			*pImage;
	ARMarkerInfo	*pMarkerInfo;
    int             iNumDetectedMarker;

	// J摜̎擾
	if( (pImage = arVideoGetImage()) != NULL )
	{
		memcpy( m_pARTImage, pImage, m_uiARTImageSize );

		m_bMarkerFound = false;

		// J摜}[J[o
		if( arDetectMarker( m_pARTImage, 130, &pMarkerInfo, &iNumDetectedMarker ) < 0 )
		{
			exit( -1 );
		}

		// oꂽ}[J[̒ԐM̍̂T
		int		k = -1;
		for( int j = 0 ; j < iNumDetectedMarker ; j++ )
		{
			if( pMarkerInfo[j].id == m_iPattID )
			{
				if( k == -1 || pMarkerInfo[j].cf > pMarkerInfo[k].cf )	k = j;
			}
		}

		if( k != -1 )
		{
			// J̃gXtH[s擾
			if( m_bFirstTime )
				arGetTransMat( &(pMarkerInfo[k]), m_dPattCenter, m_dPattWidth, m_dPattTransMat );
			else
				arGetTransMatCont( &(pMarkerInfo[k]), m_dPattTransMat, m_dPattCenter, m_dPattWidth, m_dPattTransMat );

			m_bFirstTime = false;

			m_bMarkerFound = true;
		}

		// ̃J摜̃Lv`Jn
		arVideoCapNext();

		return true;
	}

	arUtilSleep( 1 );

	return false;
}

//==============
// `掞̏
//==============
void cARTK::display( void )
{
#if 1
	// J摜`
	arglDispImage( m_pARTImage, &m_sCameraParam, 1.0, m_pArglSettings );	// zoom = 1.0.
#else
	// J摜̓l摜`
	// Ȏw肵ȂĂ arDebug = 1 ŁA arImage `悷悤ɂȂ鎖ɋCÂB
	arglDispImage( arImage, &m_sCameraParam, 1.0, m_pArglSettings );	// zoom = 1.0.
#endif
}

//====================
// J̈ʒu̎擾
//====================
void cARTK::getCameraPos( Vector3 *pvec3CamPos )
{
	double		dInvPattTransMat[3][4];

	arUtilMatInv( m_dPattTransMat, dInvPattTransMat ); // ts

	pvec3CamPos->x = (float)dInvPattTransMat[0][3];
	pvec3CamPos->y = (float)dInvPattTransMat[1][3];
	pvec3CamPos->z = (float)dInvPattTransMat[2][3];
	Vector3Transform( pvec3CamPos, pvec3CamPos, m_matCameraRotX ); // X-90x]

	// fr[g嗦|
	pvec3CamPos->x *= (float)m_dViewScaleFactor;
	pvec3CamPos->y *= (float)m_dViewScaleFactor;
	pvec3CamPos->z *= (float)m_dViewScaleFactor;
}

//============================
// vWFNVs̎擾
//============================
void cARTK::getProjectionMat( double dMat[16] )
{
								//        near  far
//	arglCameraFrustum  ( &m_sCameraParam, 0.1, 400.0, dMat ); // p: ꂾ ARToolkit̃JWn(En)ɂȂ
	arglCameraFrustumRH( &m_sCameraParam, 0.1, 400.0, dMat ); // p: AR}[J[Wn(En)
}

//========================
// fr[s̎擾
//========================
void cARTK::getModelViewMat( double dMat[16] )
{
	double	dmatTemp[16];

	// fr[g嗦|
//	arglCameraView  ( m_dPattTransMat, dmatTemp, m_dViewScaleFactor ); // ꂾ ARToolkit̃JWn(En)ɂȂ: J{̂̉Ew{Ax{
	arglCameraViewRH( m_dPattTransMat, dmatTemp, m_dViewScaleFactor ); // AR}[J[Wn(En)FJɐ΂ AR}[J[̉Ew{Ax{

#if 0
	// X+90x]
	for( int i = 0 ; i < 4 ; i++ )
	{
		int		idx = i << 2;
		dMat[idx + 0] =	m_dmatRotX[idx] * dmatTemp[0] + m_dmatRotX[idx + 1] * dmatTemp[4] + m_dmatRotX[idx + 2] * dmatTemp[ 8] + m_dmatRotX[idx + 3] * dmatTemp[12];
		dMat[idx + 1] =	m_dmatRotX[idx] * dmatTemp[1] + m_dmatRotX[idx + 1] * dmatTemp[5] + m_dmatRotX[idx + 2] * dmatTemp[ 9] + m_dmatRotX[idx + 3] * dmatTemp[13];
		dMat[idx + 2] =	m_dmatRotX[idx] * dmatTemp[2] + m_dmatRotX[idx + 1] * dmatTemp[6] + m_dmatRotX[idx + 2] * dmatTemp[10] + m_dmatRotX[idx + 3] * dmatTemp[14];
		dMat[idx + 3] =	m_dmatRotX[idx] * dmatTemp[3] + m_dmatRotX[idx + 1] * dmatTemp[7] + m_dmatRotX[idx + 2] * dmatTemp[11] + m_dmatRotX[idx + 3] * dmatTemp[15];
	}
#elif 01
	// X+90x]
	// ɂAJɐ΂ AR}[J[̉y{ɂȂBEw{͕ςȂB
	for( int i = 0 ; i < 4 ; i++ )
	{
		dMat[i*4 + 0] =	m_matModelViewRotX[i][0] * dmatTemp[0] + m_matModelViewRotX[i][1] * dmatTemp[4] + m_matModelViewRotX[i][2] * dmatTemp[ 8] + m_matModelViewRotX[i][3] * dmatTemp[12];
		dMat[i*4 + 1] =	m_matModelViewRotX[i][0] * dmatTemp[1] + m_matModelViewRotX[i][1] * dmatTemp[5] + m_matModelViewRotX[i][2] * dmatTemp[ 9] + m_matModelViewRotX[i][3] * dmatTemp[13];
		dMat[i*4 + 2] =	m_matModelViewRotX[i][0] * dmatTemp[2] + m_matModelViewRotX[i][1] * dmatTemp[6] + m_matModelViewRotX[i][2] * dmatTemp[10] + m_matModelViewRotX[i][3] * dmatTemp[14];
		dMat[i*4 + 3] =	m_matModelViewRotX[i][0] * dmatTemp[3] + m_matModelViewRotX[i][1] * dmatTemp[7] + m_matModelViewRotX[i][2] * dmatTemp[11] + m_matModelViewRotX[i][3] * dmatTemp[15];
	}
#elif 0
	// ꂾƑʖ  ԈĂ
//	argConvGlpara(m_dPattTransMat, dMat);
	argConvGlpara(dmatTemp, dMat); // ꂶRpCʂȂ
	MatrixMultiply(dMat, m_matModelViewRotX, dMat);
#else
	// ]Â܂܃Rs[
	for( int i = 0 ; i < 16 ; i++ )
	{
		dMat[i] = dmatTemp[i];
	}
#endif
}

//==============
// fr[g嗦̑
//==============
void cARTK::addViewScaleFactor( double dAdd )
{
	m_dViewScaleFactor += dAdd;

	// قǃf͑傫\
	if( m_dViewScaleFactor < 0.01 )	m_dViewScaleFactor = 0.01;
	if( 0.80 < m_dViewScaleFactor )	m_dViewScaleFactor = 0.80;
}

//======================
// CȕI
//======================
void cARTK::cleanup( void )
{
	if( m_pARTImage )
	{
		free( m_pARTImage );
		m_pARTImage = NULL;
	}

	if( m_pArglSettings )
	{
		arglCleanup( m_pArglSettings );
		m_pArglSettings = NULL;
	}
	arVideoCapStop();
	arVideoClose();
}
