//***********
// PMD{[
//***********

#ifdef	_WIN32
#include	<windows.h>
#include	<locale.h>
#endif

#include	<string.h>
#include	<math.h>
#include	<gl/glut.h>
#include	"PMDBone.h"


//================
// RXgN^
//================
cPMDBone::cPMDBone( void ) : m_pParentBone( NULL ), m_pChildBone( NULL ), m_pGrantParentBone(NULL)
{
}

//==============
// fXgN^
//==============
cPMDBone::~cPMDBone( void )
{
}

//========
// 
//========
void cPMDBone::initialize( const char * lpszBoneName, const PMX_Bone *pPMXBoneData, const cPMDBone pBoneArray[] )
{
	// {[̃Rs[
	strncpy( m_szName, lpszBoneName, 31 );
	m_szName[31] = '\0';

	// ʒũRs[
	m_vec3OrgPosition = pPMXBoneData->vec3Position;

	// {[tÕRs[
	m_nBoneFlags = pPMXBoneData->nBoneFlags;

	// ό`Kw̃Rs[
	m_nTransLevel = pPMXBoneData->nTransLevel;

	// e{[̐ݒ
	if( pPMXBoneData->nParentNo != -1 )
	{
		m_pParentBone = &(pBoneArray[pPMXBoneData->nParentNo]);
//		Vector3Sub( &m_vec3Offset, &m_vec3OrgPosition, &m_pParentBone->m_vec3OrgPosition ); // recalcOffset()ł̂ŁAł͌vZȂ
	}
	else
	{
		// eȂ
		m_vec3Offset = m_vec3OrgPosition;
	}

	// q{[̐ݒ
	if( pPMXBoneData->nChildNo != -1 )
	{
		m_pChildBone = (cPMDBone *)&(pBoneArray[pPMXBoneData->nChildNo]);
	}

	// t^e{[̐ݒ
	if ((pPMXBoneData->nBoneFlags & PMX_BONE_FLAG_ROT_GRANT) && // ]t^:1 ̏ꍇ
		(pPMXBoneData->nGrantParentNo != -1) )
	{
		m_pGrantParentBone = (cPMDBone *)&(pBoneArray[pPMXBoneData->nGrantParentNo]);
		m_fGrantRatio      = pPMXBoneData->fGrantRatio;
	}

	MatrixIdentity(	m_matInvTransform );
	m_matInvTransform[3][0] = -m_vec3OrgPosition.x; 
	m_matInvTransform[3][1] = -m_vec3OrgPosition.y; 
	m_matInvTransform[3][2] = -m_vec3OrgPosition.z; 

	m_bIKLimitAngle = false;

	// eϐ̏lݒ
	reset();
}

//============================================================================
// e{[̕ό`Kwl̂ق傫ꍇAq{[̕ό`Kwlp
// pmdf̎̂݁Bpmxf̎́Aό`Kwf[^̂܂܎ĝŎsȂ
//============================================================================
void cPMDBone::inheritTransLevel( void )
{
	if( m_pParentBone ) {
		if (m_nTransLevel < m_pParentBone->m_nTransLevel) {
			m_nTransLevel = m_pParentBone->m_nTransLevel;
		}
	}
}

//============================================================================
// ẽ{[ԍ̂ق傫ꍇɂȂ̂ŏIɍČvZ
//============================================================================
void cPMDBone::recalcOffset( void )
{
	if( m_pParentBone ) {
		Vector3Sub( &m_vec3Offset, &m_vec3OrgPosition, &m_pParentBone->m_vec3OrgPosition );
	}
}

//======================
// eϐ̏lݒ
//======================
void cPMDBone::reset( void )
{
	m_vec3Position.x = m_vec3Position.y = m_vec3Position.z = 0.0f;
	m_vec4Rotation.x = m_vec4Rotation.y = m_vec4Rotation.z = 0.0f; m_vec4Rotation.w = 1.0f;
	m_vec4LookRotation = m_vec4Rotation;

	MatrixIdentity(	m_matLocal );
	m_matLocal[3][0] = m_vec3OrgPosition.x; 
	m_matLocal[3][1] = m_vec3OrgPosition.y; 
	m_matLocal[3][2] = m_vec3OrgPosition.z; 
}


#define PI       3.14159265358979323846

//====================
// {[̍sXV
//====================
#if 01
	// PY̌̃[`

void cPMDBone::updateMatrix( void )
{
	// NH[^jIƈړl{[̃[J}gbNX쐬
	QuaternionToMatrix( m_matLocal, &m_vec4Rotation );
	m_matLocal[3][0] = m_vec3Position.x + m_vec3Offset.x; 
	m_matLocal[3][1] = m_vec3Position.y + m_vec3Offset.y; 
	m_matLocal[3][2] = m_vec3Position.z + m_vec3Offset.z; 

	// eȂẻ]󂯌p
	if( m_pParentBone ) {
		MatrixMultiply( m_matLocal, m_matLocal, m_pParentBone->m_matLocal );
	}
}

#else
	// ]t^𔽉f悤Ƃ肭sĂȂBUAۗɂÃ[`ɖ߂B

void cPMDBone::updateMatrix( bool bGrant )
{
	// NH[^jIƈړl{[̃[J}gbNX쐬

	// t^eȂt^ẻ]Z
	if (m_pGrantParentBone) {

		Vector4 vec4Temp = m_vec4Rotation; // ݂̃NH[^jI
		float ownAngle = acosf(vec4Temp.w); // ]pxƂ̔Zo
		if (ownAngle > 0.001f) {
			vec4Temp.x /= sinf(ownAngle); // ]x̐
			vec4Temp.y /= sinf(ownAngle); // ]y̐
			vec4Temp.z /= sinf(ownAngle); // ]z̐
		}
		ownAngle *= 2.0;
		float parentAngle = acosf(m_pGrantParentBone->m_vec4Rotation.w) * 2.0; // t^ẻ]pxƂZo
		ownAngle += parentAngle * m_fGrantRatio; // t^|āAZ
		while (ownAngle > 2*PI) {
			ownAngle -= 2*PI;
		}
		while (ownAngle < -2*PI) {
			ownAngle += 2*PI;
		}
		ownAngle /= 2.0;
		vec4Temp.w  = cosf(ownAngle);
		vec4Temp.x *= sinf(ownAngle);
		vec4Temp.y *= sinf(ownAngle);
		vec4Temp.z *= sinf(ownAngle);
		if (vec4Temp.w < 0.0) {
			vec4Temp.w = -vec4Temp.w;
			vec4Temp.x = -vec4Temp.x;
			vec4Temp.y = -vec4Temp.y;
			vec4Temp.z = -vec4Temp.z;
		}

		QuaternionToMatrix( m_matLocal, &vec4Temp );
	}else {
		QuaternionToMatrix( m_matLocal, &m_vec4Rotation );
	}
	m_matLocal[3][0] = m_vec3Position.x + m_vec3Offset.x; 
	m_matLocal[3][1] = m_vec3Position.y + m_vec3Offset.y; 
	m_matLocal[3][2] = m_vec3Position.z + m_vec3Offset.z; 

#if 01
	// eȂẻ]󂯌p
//	if( m_pParentBone && !m_pGrantParentBone ) { // t^ɖɂƁAڋʂ̈ʒunʂɂȂĂ܂
	if( m_pParentBone ) {
		MatrixMultiply( m_matLocal, m_matLocal, m_pParentBone->m_matLocal );
	}
#endif

	if (bGrant) {
#if 0
		// t^eȂt^ẻ]󂯌p
		if (m_pGrantParentBone) {
			Vector4 vec4GrantRatio = {0, 0, 0, m_fGrantRatio}, vec4Temp;
			// t^ě݂̃NH[^jI m_fGrantRatio{  ̕@ł͎s
			QuaternionMultiply( &vec4Temp, &m_pGrantParentBone->m_vec4Rotation, &vec4GrantRatio );
			Matrix matTemp;
			QuaternionToMatrix( matTemp, &vec4Temp );
			MatrixMultiply( m_matLocal, m_matLocal, matTemp );
		}
#elif 01
		// t^eȂt^ẻ]ɕt^|̂𔽉f
		// ڋʂяoȂc
		if (m_pGrantParentBone) {
			Vector4 vec4Temp = m_pGrantParentBone->m_vec4Rotation; // t^ě݂̃NH[^jI
#if 0
			float thetaHalf = acosf(vec4Temp.w); // ]pxƂ̔Zo
//			if (thetaHalf > 0.001f) {
			if (fabsf(thetaHalf) > 0.001f) { // acos()̕Ԃl͏ɐȂ̂ŁAfabs()͕svƎvAÔ߁B
				vec4Temp.x /= sinf(thetaHalf); // ]x̐
				vec4Temp.y /= sinf(thetaHalf); // ]y̐
				vec4Temp.z /= sinf(thetaHalf); // ]z̐
				thetaHalf *= m_fGrantRatio; // ]pxƂ̔ɕt^|
	//			thetaHalf = 0.0; // eXgFeȂ͂ǂȂH
				vec4Temp.w  = cosf(thetaHalf); // NH[^jIēx쐬
				vec4Temp.x *= sinf(thetaHalf);
				vec4Temp.y *= sinf(thetaHalf);
				vec4Temp.z *= sinf(thetaHalf);
//				QuaternionNormalize( &vec4Temp, &vec4Temp ); // ɐKłĂ̂ŕsv
			}
#else
			if (vec4Temp.w < 0.9999f) { // double ɂĂڋʂяo
				double thetaHalf = acos(vec4Temp.w); // ]pxƂ̔Zo
				double thetaHalfNew = thetaHalf * m_fGrantRatio; // ]pxƂ̔ɕt^|
				double ratio = sin(thetaHalfNew) / sin(thetaHalf);
				vec4Temp.w  = cos(thetaHalfNew); // NH[^jIēx쐬
				vec4Temp.x *= ratio; // ]x̐
				vec4Temp.y *= ratio; // ]y̐
				vec4Temp.z *= ratio; // ]z̐
//				QuaternionNormalize( &vec4Temp, &vec4Temp ); // ɐKłĂ̂ŕsv
			}
#endif
			Matrix matTemp;
			QuaternionToMatrix( matTemp, &vec4Temp );
			MatrixMultiply( m_matLocal, m_matLocal, matTemp );
		}
#endif
	} else {
#if 0
		// eȂẻ]󂯌p
		if( m_pParentBone ) {
			MatrixMultiply( m_matLocal, m_matLocal, m_pParentBone->m_matLocal );
		}
#endif
	}
}

#endif


#define		RAD(a)	(a * (3.1415926f / 180.0f))
#define		DEG(a)	(a * (180.0f / 3.1415926f))

//==========================
// {[wW֌
//==========================
void cPMDBone::lookAt( const Vector3 *pvecTargetPos, float fLimitXD, float fLimitXU, float fLimitY  )
{
	// ǂ̂ŗv

	Matrix	matTemp;

	MatrixIdentity(	matTemp );
	matTemp[3][0] = m_vec3Position.x + m_vec3Offset.x; 
	matTemp[3][1] = m_vec3Position.y + m_vec3Offset.y; 
	matTemp[3][2] = m_vec3Position.z + m_vec3Offset.z;

	if( m_pParentBone )
	{
		Matrix	matInvTemp;
		MatrixInverse( matInvTemp, m_pParentBone->m_matLocal );
		matInvTemp[3][0] =  m_pParentBone->m_matLocal[3][0]; 
		matInvTemp[3][1] =  m_pParentBone->m_matLocal[3][1]; 
		matInvTemp[3][2] = -m_pParentBone->m_matLocal[3][2];
		MatrixMultiply( matTemp, matTemp, matInvTemp );
	}
	MatrixInverse( matTemp, matTemp );

	Vector3		vec3LocalTgtPosZY;
	Vector3		vec3LocalTgtPosXZ;

	Vector3Transform( &vec3LocalTgtPosZY, pvecTargetPos, matTemp );

	vec3LocalTgtPosXZ = vec3LocalTgtPosZY;
	vec3LocalTgtPosXZ.y = 0.0f;
	Vector3Normalize( &vec3LocalTgtPosXZ, &vec3LocalTgtPosXZ );

	vec3LocalTgtPosZY.x = 0.0f;
	Vector3Normalize( &vec3LocalTgtPosZY, &vec3LocalTgtPosZY );

	Vector3		vec3Angle = { 0.0f, 0.0f, 0.0f };

	vec3Angle.x =  asinf( vec3LocalTgtPosZY.y );
	if( vec3LocalTgtPosXZ.x < 0.0f )	vec3Angle.y =  acosf( vec3LocalTgtPosXZ.z );
	else								vec3Angle.y = -acosf( vec3LocalTgtPosXZ.z );

	if( vec3Angle.x < RAD(fLimitXD) )	vec3Angle.x = RAD(fLimitXD);
	if( RAD(fLimitXU) < vec3Angle.x )	vec3Angle.x = RAD(fLimitXU);

	if( vec3Angle.y < RAD(-fLimitY) )	vec3Angle.y = RAD(-fLimitY);
	if( RAD(fLimitY) < vec3Angle.y  )	vec3Angle.y = RAD( fLimitY);

	Vector4		vec4RotTemp;

	QuaternionCreateEuler( &vec4RotTemp, &vec3Angle );
	QuaternionSlerp( &m_vec4LookRotation, &m_vec4LookRotation, &vec4RotTemp, 0.3f );

	m_vec4Rotation = m_vec4LookRotation;
}

//========================
// XLjOpsXV
//========================
void cPMDBone::updateSkinningMat( void )
{
	MatrixMultiply( m_matSkinning, m_matInvTransform, m_matLocal );
}

//==============
// fobO`
//==============
void cPMDBone::debugDraw( void )
{
	glDisable( GL_TEXTURE_2D );

	glPushMatrix();

		glMultMatrixf( (const float *)m_matLocal );

		glColor4f( 1.0f, 0.0f, 1.0f, 1.0f );

		glutSolidCube( 0.3f );

	glPopMatrix();

	glPushMatrix();

		glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );

		if( m_pParentBone )
		{
			glBegin( GL_LINES );
				glVertex3f( m_pParentBone->m_matLocal[3][0], m_pParentBone->m_matLocal[3][1], m_pParentBone->m_matLocal[3][2] );
				glVertex3f(                m_matLocal[3][0],                m_matLocal[3][1],                m_matLocal[3][2] );
			glEnd();
		}

	glPopMatrix();
}
