//***********
// PMD{[
//***********

#ifndef	_PMDBONE_H_
#define	_PMDBONE_H_

#include	"PMDTypes.h"
#include	"PMXTypes.h"


class cPMDBone
{
	private :
		char			m_szName[32];

		bool			m_bIKLimitAngle;	// IKɊpx邩ǂ

		Vector3			m_vec3OrgPosition;
		Vector3			m_vec3Offset;

		Matrix			m_matInvTransform;	// l̃{[_Ɉړ悤ȍs

		ushort			m_nBoneFlags;		// {[tO

		long			m_nTransLevel;		// ό`Kw

		const cPMDBone	*m_pParentBone;		// e{[
		cPMDBone		*m_pChildBone;		// q{[

		cPMDBone		*m_pGrantParentBone;	//t^e{[
		float			m_fGrantRatio;			// t^

		// ȉ݂͌̒l
		Vector3			m_vec3Position;
		Vector4			m_vec4Rotation;

		Matrix			m_matLocal;

		Vector4			m_vec4LookRotation;

	public :
		Matrix			m_matSkinning;		// _ftH[ps

		cPMDBone( void );
		~cPMDBone( void );

//		void initialize( const char * lpszBoneName, const PMD_Bone *pPMDBoneData, const cPMDBone pBoneArray[] );
		void initialize( const char * lpszBoneName, const PMX_Bone *pPMXBoneData, const cPMDBone pBoneArray[] );

		void inheritTransLevel( void );
		void recalcOffset( void );

		void reset( void );

		void updateMatrix( void );
		void lookAt( const Vector3 *pvecTargetPos, float fLimitXD, float fLimitXU, float fLimitY  );
		void updateSkinningMat( void );

		void debugDraw( void );

		inline const char *getName( void ){ return m_szName; }
		inline ushort getBoneFlags  (void) { return m_nBoneFlags; }
		inline long   getTransLevel (void) { return m_nTransLevel; }
		inline void getOrgPos( Vector3 *pvec3Out ){ *pvec3Out = m_vec3OrgPosition; }
		inline void getPos( Vector3 *pvec3Out ){ pvec3Out->x = m_matLocal[3][0]; pvec3Out->y = m_matLocal[3][1]; pvec3Out->z = m_matLocal[3][2]; }
		inline Matrix &getLocalMatrix( void ){ return m_matLocal; };

	friend class cMotionPlayer;
	friend class cPMDIK;
	friend class cPMDRigidBody;
};

#endif	// _PMDMODEL_H_
