//***************
// PMD\f[^
//***************

#include	<gl/glut.h>
#include	<stdio.h>
#include	<malloc.h>
#include	<string.h>
#include	"PMDFace.h"

//================
// RXgN^
//================
cPMDFace::cPMDFace( void ) : m_pFaceVertices( NULL )
{
}

//==============
// fXgN^
//==============
cPMDFace::~cPMDFace( void )
{
	release();
}

//========
// 
//========
void cPMDFace::initialize( const char * lpszFaceName, const PMD_Face *pPMDFaceData, const cPMDFace *pPMDFaceBase, const Vector3 * pvec3OrgPositionArray )
{
	release();


	// \̃Rs[
	strncpy( m_szName, lpszFaceName, 256 );
	m_szName[255] = '\0';

	// \_f[^̃Rs[
	m_ulNumVertices = pPMDFaceData->ulNumVertices;

	m_pFaceVertices = (PMD_FaceVtx *)malloc( sizeof(PMD_FaceVtx) * m_ulNumVertices );
	memcpy( m_pFaceVertices, pPMDFaceData->pVertices, sizeof(PMD_FaceVtx) * m_ulNumVertices );

	// baseƂ̑΃CfbNX΃CfbNXɕϊ
	if( pPMDFaceBase && pPMDFaceBase != this )
	{
		PMD_FaceVtx	*pVertex = m_pFaceVertices;
		for( unsigned long i = 0 ; i < m_ulNumVertices ; i++ )
		{
			Vector3Add( &pVertex->vec3Pos, &pPMDFaceBase->m_pFaceVertices[pVertex->ulIndex].vec3Pos, &pVertex->vec3Pos );
			pVertex->ulIndex = pPMDFaceBase->m_pFaceVertices[pVertex->ulIndex].ulIndex;
			pVertex++;
		}
	}

	// PMXp: WItZbgʂ΍Wɕϊ
	if (pvec3OrgPositionArray) 
	{
		PMD_FaceVtx	*pVertex = m_pFaceVertices;
		for( unsigned long i = 0 ; i < m_ulNumVertices ; i++ )
		{
			Vector3Add( &pVertex->vec3Pos, &pvec3OrgPositionArray[pVertex->ulIndex], &pVertex->vec3Pos );
			pVertex++;
		}
	}
}

//============
// \Kp
//============
void cPMDFace::setFace( Vector3 *pvec3Vertices )
{
	if( !m_pFaceVertices )	return;

	PMD_FaceVtx		*pVertex = m_pFaceVertices;
	for( unsigned long i = 0 ; i < m_ulNumVertices ; i++ )
	{
		pvec3Vertices[pVertex->ulIndex] = pVertex->vec3Pos;
		pVertex++;
	}
}

//======================
// \uhœKp
//======================
void cPMDFace::blendFace( Vector3 *pvec3Vertices, float fRate )
{
	if( !m_pFaceVertices )	return;

	PMD_FaceVtx		*pVertex = m_pFaceVertices;
	unsigned long	ulIndex;
	for( unsigned long i = 0 ; i < m_ulNumVertices ; i++ )
	{
		ulIndex = pVertex->ulIndex;
		Vector3Lerp( &pvec3Vertices[ulIndex], &pvec3Vertices[ulIndex], &pVertex->vec3Pos, fRate );
		pVertex++;
	}
}

//======
// 
//======
void cPMDFace::release( void )
{
	if( m_pFaceVertices )
	{
		free( m_pFaceVertices );
		m_pFaceVertices = NULL;
	}
}
