//***********
// PMDf
//***********

#include	<stdio.h>
#include	<stdlib.h>
#include	<malloc.h>
#include	<string.h>

#ifdef	_WIN32
#include	<windows.h>
#include	<locale.h>
#endif

#include	<gl/glut.h>
#include	<gl/glext.h>

#include	"PMDModel.h"
#include	"TextureList.h"

#define	_DBG_BONE_DRAW		(0)
#define	_DBG_IK_DRAW		(0)
#define	_DBG_TEXTURE_DRAW	(0)


// Qfmœ̃eNX`Ɩ肪̂ŁAO[oϐłȂ悤ɂB
//extern cTextureList	g_clsTextureList0; // eNX`jbg0p
//extern cTextureList	g_clsTextureList1; // eNX`jbg1p


// glext.h ̋@\F֐|C^
PFNGLACTIVETEXTUREPROC        glActiveTexture;
PFNGLCLIENTACTIVETEXTUREPROC  glClientActiveTexture;
//PFNGLMULTITEXCOORD2FPROC      glMultiTexCoord2f;
PFNGLCOMPRESSEDTEXIMAGE2DPROC glCompressedTexImage2D;

////////////////////////
// OpenGL ext@\̏
////////////////////////
void Init_OpenGL_ExtFunc (void)
{
	// glext.h ɒǉꂽ@\

	// }`eNX`Ή
	glActiveTexture = (PFNGLACTIVETEXTUREPROC)wglGetProcAddress("glActiveTextureARB");
	if (glActiveTexture == NULL) {
		MessageBox (NULL, L"Not support glActiveTextureARB", L"ARTK_MMD_TWINS", MB_OK);
	}
	glClientActiveTexture = (PFNGLCLIENTACTIVETEXTUREPROC)wglGetProcAddress("glClientActiveTextureARB");
	if (glActiveTexture == NULL) {
		MessageBox (NULL, L"Not support glClientActiveTextureARB", L"ARTK_MMD_TWINS", MB_OK);
	}
//	glMultiTexCoord2f = (PFNGLMULTITEXCOORD2FPROC)wglGetProcAddress("glMultiTexCoord2fARB");
//	if (glActiveTexture == NULL) {
//		MessageBox (NULL, L"Not support glMultiTexCoord2fARB", L"ARTK_MMD_TWINS", MB_OK);
//	}
	glCompressedTexImage2D = (PFNGLCOMPRESSEDTEXIMAGE2DPROC)wglGetProcAddress("glCompressedTexImage2DARB");;
	if (glCompressedTexImage2D == NULL) {
		MessageBox (NULL, L"Not support glCompressedTexImage2DARB", L"ARTK_MMD_TWINS", MB_OK);
	}
}


//--------------------------
// IKf[^\[gpr֐
//--------------------------
static int compareFunc( const void *pA, const void *pB )
{
	return (int)(((cPMDIK *)pA)->getSortVal() - ((cPMDIK *)pB)->getSortVal());
}

//================
// RXgN^
//================
cPMDModel::cPMDModel( void ) : m_pvec3OrgPositionArray( NULL ), m_pvec3OrgPositionArray0( NULL ), m_pvec3OrgNormalArray( NULL ), m_puvOrgTexureUVArray( NULL ),
									m_pOrgSkinInfoArray( NULL ), m_pvec3PositionArray( NULL ), m_pvec3NormalArray( NULL ), m_pIndices( NULL ),
										m_pMaterials( NULL ), m_pBoneArray( NULL ), m_pNeckBone( NULL), m_pIKArray( NULL ), m_pFaceArray( NULL ),
											m_pRigidBodyArray( NULL ), m_pConstraintArray( NULL ),
												m_pTexInfo( NULL )
{
}

//==============
// fXgN^
//==============
cPMDModel::~cPMDModel( void )
{
	release();
}

//====================
// t@C̓ǂݍ
//====================
bool cPMDModel::load( const char *szFilePath )
{
	FILE	*pFile;
	fpos_t	fposFileSize;
	unsigned char
			*pData;

	pFile = fopen( szFilePath, "rb" );
	if( !pFile )	return false;	// t@CJȂ

	// t@CTCY擾
	fseek( pFile, 0, SEEK_END );
	fgetpos( pFile, &fposFileSize );

	// m
	pData = (unsigned char *)malloc( (size_t)fposFileSize );

	// ǂݍ
	fseek( pFile, 0, SEEK_SET );
	fread( pData, 1, (size_t)fposFileSize, pFile );

	fclose( pFile );


	release();
	m_clMotionPlayer.clear();

	m_bPmx    = false;
	m_bLookAt = false;


	// pmd ff[^
	bool	bRet = initializePMD( pData, fposFileSize );
	if (bRet == false) {
		// pmx ff[^
		bRet = initializePMX( pData, fposFileSize );
		m_bPmx = true;
	}

	free( pData );

	return bRet;
}

//======================
// PMD ff[^̏
//======================
bool cPMDModel::initializePMD( unsigned char *pData, unsigned long ulDataSize )
{
	unsigned char *pDataTop = pData;

	// PMD wb_̃`FbN
	PMD_Header	*pPMDHeader = (PMD_Header *)pData;
	if( pPMDHeader->szMagic[0] != 'P' || pPMDHeader->szMagic[1] != 'm' || pPMDHeader->szMagic[2] != 'd' || pPMDHeader->fVersion != 1.0f )
		return false;	// t@C`Ⴄ

	// PMDf̃Rs[
	strncpy( m_szModelName, pPMDHeader->szName, 20 );
	m_szModelName[20] = '\0';

	pData += sizeof( PMD_Header );

	unsigned long	ulSize;

	//-----------------------------------------------------
	// _擾
	m_ulNumVertices = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// _zRs[
	m_pvec3OrgPositionArray =  (Vector3 *)malloc( sizeof(Vector3)  * m_ulNumVertices );
	m_pvec3OrgNormalArray   =  (Vector3 *)malloc( sizeof(Vector3)  * m_ulNumVertices );
	m_puvOrgTexureUVArray   =    (TexUV *)malloc( sizeof(TexUV)    * m_ulNumVertices );
	m_pOrgSkinInfoArray     = (SkinInfo *)malloc( sizeof(SkinInfo) * m_ulNumVertices ); 

	PMD_Vertex	*pVertex = (PMD_Vertex *)pData;
	for( unsigned long i = 0 ; i < m_ulNumVertices ; i++, pVertex++ )
	{
		m_pvec3OrgPositionArray[i] =  pVertex->vec3Pos;
		m_pvec3OrgNormalArray  [i] =  pVertex->vec3Normal;
		m_puvOrgTexureUVArray  [i] =  pVertex->uvTex;

		m_pOrgSkinInfoArray[i].fWeight [0] = pVertex->cbWeight / 100.0f; 
		m_pOrgSkinInfoArray[i].fWeight [1] = 1.0 - m_pOrgSkinInfoArray[i].fWeight[0]; // ňZĂ
		m_pOrgSkinInfoArray[i].unBoneNo[0] = pVertex->unBoneNo[0]; 
		m_pOrgSkinInfoArray[i].unBoneNo[1] = pVertex->unBoneNo[1]; 
		m_pOrgSkinInfoArray[i].nWeightType = 1; // EFCgό`: BDEF2
	}

	ulSize = sizeof( PMD_Vertex ) * m_ulNumVertices;
	pData += ulSize;

	// XLjOp_z쐬
	m_pvec3PositionArray = (Vector3 *)malloc( sizeof(Vector3) * m_ulNumVertices );
	m_pvec3NormalArray   = (Vector3 *)malloc( sizeof(Vector3) * m_ulNumVertices );


	//-----------------------------------------------------
	// _CfbNX擾
	m_ulNumIndices = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// _CfbNXzRs[
	ulSize = sizeof( unsigned long ) * m_ulNumIndices;
	m_pIndices = (unsigned long *)malloc( ulSize );

	unsigned long *pIndices = m_pIndices;

	for( unsigned long i = 0 ; i < m_ulNumIndices ; i++ )
	{
		*pIndices++ = *(unsigned short *)pData; // 16bit lA32bit ɕϊȂARs[
		pData += sizeof( unsigned short );
	}

	//-----------------------------------------------------
	// }eA擾
	m_ulNumMaterials = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// }eAzRs[
	m_pMaterials = (Material *)malloc( sizeof(Material) * m_ulNumMaterials );

	PMD_Material	*pPMDMaterial = (PMD_Material *)pData;
	for( unsigned long i = 0 ; i < m_ulNumMaterials ; i++ )
	{
		m_pMaterials[i].col4Diffuse = pPMDMaterial->col4Diffuse;

		m_pMaterials[i].col4Specular.r = pPMDMaterial->col3Specular.r;
		m_pMaterials[i].col4Specular.g = pPMDMaterial->col3Specular.g;
		m_pMaterials[i].col4Specular.b = pPMDMaterial->col3Specular.b;
		m_pMaterials[i].col4Specular.a = 1.0f;

		m_pMaterials[i].col4Ambient.r = pPMDMaterial->col3Ambient.r;
		m_pMaterials[i].col4Ambient.g = pPMDMaterial->col3Ambient.g;
		m_pMaterials[i].col4Ambient.b = pPMDMaterial->col3Ambient.b;
		m_pMaterials[i].col4Ambient.a = 1.0f;

		m_pMaterials[i].fShininess   = pPMDMaterial->fShininess;

		m_pMaterials[i].cbFlags      = 0;
		if (m_pMaterials[i].col4Diffuse.a < 1.0f) { // 1.0̎͗ʕ`
			m_pMaterials[i].cbFlags |= PMX_MAT_FLAG_BOTH;
		}
		if (pPMDMaterial->cbEdge) {
			m_pMaterials[i].cbFlags |= PMX_MAT_FLAG_EDGE;
		}

		m_pMaterials[i].ulNumIndices = pPMDMaterial->ulNumIndices;

		// Ƃ肠AeLX`̐ݒɂ
		m_pMaterials[i].uiTexID     = 0xFFFFFFFF;
		m_pMaterials[i].uiSphereID  = 0xFFFFFFFF;
//		m_pMaterials[i].bSphereMap  = false;
		m_pMaterials[i].nSphereMode = 0;

		if( pPMDMaterial->szTextureFileName[0] )
		{
			char szTexFileName[32], *lpszTexFileName = szTexFileName, *lpszSphereFileName = NULL;
			strncpy (szTexFileName, pPMDMaterial->szTextureFileName, 20);  // 20LbJ '\0' tĂȂꍇɂΉ
			szTexFileName[20] = '\0';  // strncpy() ͒鎞 '\0' IɕtĂȂ̂ŁA蓮ŕtĂ
			lpszSphereFileName = strchr (szTexFileName, '*');
			if (lpszSphereFileName) { // "face.bmp*face.spa"ƌ悤ȏԂł
				*lpszSphereFileName++ = '\0'; // lpszTexFileName ̕"face.bmp"ɁAlpszSphereFileName ̕"face.spa"ɕ
				if (isSphereMapTexName(lpszSphereFileName, false)) { // ZXtBAt@C(sph)
					m_pMaterials[i].nSphereMode = 1; // XtBAZ
				} else if (isSphereMapTexName(lpszSphereFileName, true)) { // ZXtBAt@C(spa)
					m_pMaterials[i].nSphereMode = 2; // XtBAZ
				} else {
					lpszSphereFileName = NULL; // XtBAt@Cł͂Ȃ
				}
			} else { // "face.bmp*face.spa"ƌ悤ȏԂł͖
				if (isSphereMapTexName( szTexFileName, false )) { // "face.sph"ƌ悤ȏԂł
//					// ʏeLX`XtBAƂĈ悤ɂ  IWi ARTK_MMD ƌ݊̕@BǁAeNX`jbg𓱓̂Ŏ~߂B
//					m_pMaterials[i].bSphereMap = true;
					// ւ
					lpszSphereFileName = szTexFileName;  // XtBAeLX`
					lpszTexFileName    = NULL;           // ʏeNX`͖
					m_pMaterials[i].nSphereMode = 1; // XtBAZ
				} else if (isSphereMapTexName( szTexFileName, true )) { // "face.spa"ƌ悤ȏԂł
					// ւ
					lpszSphereFileName = szTexFileName;  // XtBAeLX`
					lpszTexFileName    = NULL;           // ʏeNX`͖
					m_pMaterials[i].nSphereMode = 2; // XtBAZ
					
//					wchar_t szMsg[256];
//					setlocale( LC_ALL, "Japanese_Japan.932" );
//					mbstowcs( szMsg, lpszSphereFileName, 255 );
//					MessageBox(NULL, szMsg, L"spa Texture only", MB_OK);
				}
			}
			if (lpszTexFileName) { // ʏeNX`L
				/* eNX`jbgOɖ߂ */
				glActiveTexture(GL_TEXTURE0);
				m_pMaterials[i].uiTexID = m_clsTextureList0.getTexture( lpszTexFileName );
			}
			if (lpszSphereFileName) { // XtBAeNX`L
				/* eNX`jbgPɐ؂ւ */
				glActiveTexture(GL_TEXTURE1);
				m_pMaterials[i].uiSphereID = m_clsTextureList1.getTexture( lpszSphereFileName );
			}
		}

		pPMDMaterial++;
	}

	pData += sizeof(PMD_Material) * m_ulNumMaterials;

	/* eNX`jbgOɖ߂ */
	glActiveTexture(GL_TEXTURE0);


	//-----------------------------------------------------
	// {[擾
	m_unNumBones = *((unsigned short *)pData);
	pData += sizeof( unsigned short );

	// {[z쐬
	m_pBoneArray = new cPMDBone[m_unNumBones];

	PMX_Bone pmxBone;
	memset (&pmxBone, 0, sizeof(PMX_Bone));
	Vector3 vecNul3 = {0,0,0};

	m_nMaxBoneTransLevel = 2; // {[̍őό`Kw: pmd̏ꍇ͍ő2ŌŒ

	for( unsigned long i = 0 ; i < m_unNumBones ; i++ )
	{
		char szBoneName[32]; // {[:20oCg
		strncpy( szBoneName, (const char *)pData, 20 );
		szBoneName[20] = '\0';
		pData += 20;

		const PMD_Bone *pPMDBone = (const PMD_Bone *)pData;
		pData += sizeof( PMD_Bone );

		// pmd {[f[^ pmx {[f[^ɕϊ

		// Ƃ肠
		pmxBone.vec3Position     = pPMDBone->vec3Position; // f_̈ʒu
		pmxBone.nBoneFlags       = 0; // {[tO
		pmxBone.nTransLevel      = 0; // ό`Kw
		pmxBone.nParentNo        = pPMDBone->nParentNo; // e{[ԍ (Ȃ -1)
		pmxBone.nChildNo         = pPMDBone->nChildNo;  // q{[ԍ (Ȃ -1)
		pmxBone.nGrantParentNo   = -1;   // t^e{[ԍ (Ȃ -1)
		pmxBone.fGrantRatio      = 0.0; // t^
		pmxBone.vec3AxisLimitDir = vecNul3; // Œ̕xNg
		
		if (pmxBone.nChildNo == 0) { // MMD7.39dott߈ȍ~ 0 ɂȂĂ̂ŁA-1 ɏC
			pmxBone.nChildNo = -1;
		}

		// ̃{[tOւ̕ϊĺAɖkP PMDGfB^PMXGfB^ɁA
		//  pmdt@Cǂݍ܂̔rāAvB
		switch (pPMDBone->cbKind) {
		case 0: // ]
			pmxBone.nBoneFlags       = 0x001B; // {[tO
			break;
		case 1: // ]/ړ
			pmxBone.nBoneFlags       = 0x001F; // {[tO
			break;
		case 2: // IK
			pmxBone.nBoneFlags       = 0x003F; // {[tO
			pmxBone.nTransLevel      = 1; // ό`Kw
			break;
//		case 3: // s  ʂsBĂ pmdft@C݂͑ȂH
//			break;
		case 4: // IKe(])
			pmxBone.nBoneFlags       = 0x001B; // {[tO
			break;
		case 5: // ]e
			pmxBone.nBoneFlags       = 0x011B; // {[tO
			pmxBone.nTransLevel      = 2; // ό`Kw
			pmxBone.nGrantParentNo   = pPMDBone->nGrantData;   // t^e{[ԍ (Ȃ -1)
			pmxBone.fGrantRatio      = 1.0; // t^: 100%  1.0ɕϊ
			break;
		case 6: // IKڑ
			pmxBone.nBoneFlags       = 0x0013; // {[tO
			break;
		case 7: // \
			pmxBone.nBoneFlags       = 0x0013; // {[tO
			break;
		case 8: // Ђ˂
			pmxBone.nBoneFlags       = 0x041A; // {[tO
			pmxBone.vec3AxisLimitDir = vecNul3; // Œ̕xNg: *.vmd Đɂ͕svȂ̂ŁA^ʖڂɌvZĂȂ
			break;
		case 9: // ]A
			pmxBone.nBoneFlags       = 0x0112; // {[tO
			pmxBone.nChildNo         = -1;  // q{[ԍ͖
			pmxBone.nGrantParentNo   = pPMDBone->nChildNo;   // t^e{[ԍ
			pmxBone.fGrantRatio      = pPMDBone->nGrantData / 100.0f; // t^: 0`100%  0.0`1.0ɕϊ
			break;
		}

		m_pBoneArray[i].initialize( szBoneName, &pmxBone, m_pBoneArray );

		// ̃{[ۑ
		if( strncmp( m_pBoneArray[i].getName(), "", 20 ) == 0 )	m_pNeckBone = &m_pBoneArray[i];

	}

	// e{[̕ό`Kwl̂ق傫ꍇAq{[̕ό`Kwlp
	for( unsigned long i = 0 ; i < m_unNumBones ; i++ ) {
		m_pBoneArray[i].inheritTransLevel();
	}

	// ẽ{[ԍ̂ق傫ꍇɂȂ̂ŏIɍČvZ
	for( unsigned long i = 0 ; i < m_unNumBones ; i++ ) {
		m_pBoneArray[i].recalcOffset();
	}

	//-----------------------------------------------------
	// IK擾
	m_unNumIK = *((unsigned short *)pData);
	pData += sizeof( unsigned short );

	// IKz쐬
	if( m_unNumIK )
	{
		m_pIKArray = new cPMDIK[m_unNumIK];

		for( unsigned short i = 0 ; i < m_unNumIK ; i++ )
		{
			const PMD_IK *pPmdIK = (const PMD_IK *)pData;
			PMX_IK pmxIk; // pmd IKf[^ pmx pɕϊ
			pmxIk.nTargetNo = pPmdIK->nTargetNo;	// IK^[Qbg{[ԍ
			pmxIk.nEffNo    = pPmdIK->nEffNo;		// IK[{[ԍ
			pmxIk.cbNumLink = pPmdIK->cbNumLink;	// IK\{[̐
			pmxIk.unCount   = pPmdIK->unCount;		// ċAZ // IKl1
			pmxIk.fFact     = pPmdIK->fFact;		// Z1񂠂̐px // IKl2
			for (unsigned char j = 0 ; j < pmxIk.cbNumLink ; j++) {
				pmxIk.punLinkNo[j] = pPmdIK->punLinkNo[j];// IK\{[̔z: 256𒴂stackj󂷂 PMDf̏ꍇ255ȉȂ̂ŔȂ
			}
			pData += sizeof( PMD_IK ) + sizeof(short) * (pmxIk.cbNumLink - 1);
			m_pIKArray[i].initialize( &pmxIk, m_pBoneArray );
		}
		qsort( m_pIKArray, m_unNumIK, sizeof(cPMDIK), compareFunc );
	}

	//-----------------------------------------------------
	// \擾
	// サ~N̏ꍇAOɂȂB㑱́uサ~NΉvĂȂƁArŐԁB
	m_unNumFaces = *((unsigned short *)pData);
	pData += sizeof( unsigned short );

	// \z쐬
	if( m_unNumFaces )
	{
		m_pFaceArray = new cPMDFace[m_unNumFaces];

		for( unsigned short i = 0 ; i < m_unNumFaces ; i++ )
		{
			char szFaceName[32]; // \:20oCg
			strncpy( szFaceName, (const char *)pData, 20 );
			szFaceName[20] = '\0';
			pData += 20;

			m_pFaceArray[i].initialize( szFaceName, (const PMD_Face *)pData, &m_pFaceArray[0], NULL ); // base\(m_pFaceArray[0])ɐ΍WvZ
			pData += sizeof( PMD_Face ) + sizeof(PMD_FaceVtx) * (((PMD_Face *)pData)->ulNumVertices - 1);
		}
	}

	//-----------------------------------------------------
	// 獄̏܂œǂݔ΂

	// \gp\Xg
	unsigned char	cbFaceDispNum = *((unsigned char *)pData);
	pData += sizeof( unsigned char );

	pData += sizeof( unsigned short ) * cbFaceDispNum;

	// {[gpgXg
	unsigned char	cbBoneDispNum = *((unsigned char *)pData);
	pData += sizeof( unsigned char );

	pData += sizeof( char ) * 50 * cbBoneDispNum;

	// {[gp\Xg
	unsigned long	ulBoneFrameDispNum = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	pData += 3 * ulBoneFrameDispNum;

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return true;

	// pꖼΉ
	unsigned char	cbEnglishNameExist = *((unsigned char *)pData);
	pData += sizeof( unsigned char );

	if( cbEnglishNameExist )
	{
		// fƃRg(p)
		pData += sizeof( char ) * 276;

		// {[(p)
		pData += sizeof( char ) * 20 * m_unNumBones;

		// \(p)
		if (m_unNumFaces) { // サ~NΉ
			pData += sizeof( char ) * 20 * (m_unNumFaces - 1);	// "base"͉pꖼXgɂ͊܂܂Ȃ
		}

		// {[gpgXg(p)
		pData += sizeof( char ) * 50 * (cbBoneDispNum);
	}

	// 㑱f[^̗L`FbN(̃`FbN͕sv)
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return true;

	// gD[eNX`Xg
	pData += 100 * 10;		// t@C 100Byte * 10

	// ܂œǂݔ΂
	//-----------------------------------------------------

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return true;

	//-----------------------------------------------------
	// ̐擾
	m_ulRigidBodyNum = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// ̔z쐬
	if( m_ulRigidBodyNum )
	{
		m_pRigidBodyArray = new cPMDRigidBody[m_ulRigidBodyNum]; // サ~NΉĂȂƁAŐԁB

		for( unsigned long i = 0 ; i < m_ulRigidBodyNum ; i++ )
		{
//			char szRigidBodyName[32]; // ̖:20oCg
//			strncpy( szRigidBodyName, (const char *)pData, 20 );
//			szRigidBodyName[20] = '\0';
			pData += 20;

			long nBoneIndex = *(unsigned short *)pData;	// ֘A{[ԍ
			pData += sizeof(unsigned short);

			const PMD_RigidBody *pPMDRigidBody = (const PMD_RigidBody *)pData;

			cPMDBone	*pBone = NULL;
			if( nBoneIndex == 0xFFFF )	pBone = getBoneByName( "Z^[" );
			else						pBone = &m_pBoneArray[nBoneIndex];

			m_pRigidBodyArray[i].initialize( nBoneIndex, pPMDRigidBody, pBone );
			pData += sizeof( PMD_RigidBody );
		}
	}


	// 㑱f[^̗L`FbN: サ~NΉ
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return true;


	//-----------------------------------------------------
	// RXgCg擾
	m_ulConstraintNum = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// RXgCgz쐬
	if( m_ulConstraintNum )
	{
		m_pConstraintArray = new cPMDConstraint[m_ulConstraintNum];

		for( unsigned long i = 0 ; i < m_ulConstraintNum ; i++ )
		{
//			char szConstraintName[32]; // RXgCg:20oCg
//			strncpy( szConstraintName, (const char *)pData, 20 );
//			szConstraintName[20] = '\0';
			pData += 20;

			ulong ulRigidA = *(ulong *)pData;		// A
			pData += sizeof(ulong);
			ulong ulRigidB = *(ulong *)pData;		// B
			pData += sizeof(ulong);

			const PMD_Constraint *pPMDConstraint = (const PMD_Constraint *)pData;

			cPMDRigidBody	*pRigidBodyA = &m_pRigidBodyArray[ulRigidA],
							*pRigidBodyB = &m_pRigidBodyArray[ulRigidB];

			m_pConstraintArray[i].initialize( pPMDConstraint, pRigidBodyA, pRigidBodyB );
			pData += sizeof( PMD_Constraint );
		}
	}

	return true;
}

//======================
// pmxff[^Text̃Rs[
// Unicode  SJIS ɕϊ
// Ԃl͎̃f[^|C^
//======================
unsigned char * cPMDModel::copyPmxText( unsigned char *pData, char * lpszTextBuff, size_t nTextBuffSize )
{
	// oCgo
	long nLen = *(long *)pData;
	pData += sizeof(long);

	wchar_t wszBuff[1024], *lpwszTemp;

	if (m_nExByte[PMX_EX_ENC] == 0) { // UTF16
		if (nLen) {
			memcpy (wszBuff, pData, nLen);  // ̂܂܂ 1024[h𒴂ƐԂAƂ肠uB
			pData += nLen;
		}
		wszBuff[nLen/2] = L'\0';
	} else { // UTF8
		lpwszTemp = wszBuff;
		while (nLen) {
			uchar utf8 = *pData++;
			--nLen;
			if (utf8 < 0x80) { // 1oCgUTF8 = ASCII
				*lpwszTemp++ = (wchar_t)utf8;
			} else if (utf8 < 0xC0) { // 肦Ȃ: 0x80`0xBF
				*lpwszTemp++ = L'?';
			} else if (utf8 < 0xE0) { // 2oCgUTF8: 0xC0`0xDF
				wchar_t utf16 = (wchar_t)(utf8 - 0xC0);
				utf16 <<= 6; // 5bit
				wchar_t low = (wchar_t)(*pData++ & 0x3F); // 6bit
				utf16 += low;
				--nLen;
				*lpwszTemp++ = utf16;
			} else if (utf8 < 0xF0) { // 3oCgUTF8: 0xE0`0xEF
				wchar_t utf16 = (wchar_t)(utf8 - 0xE0);
				utf16 <<= 12; // 4bit
				wchar_t mid = (wchar_t)(*pData++ & 0x3F); // 6bit
				utf16 += mid << 6;
				wchar_t low = (wchar_t)(*pData++ & 0x3F); // 6bit
				utf16 += low;
				nLen  -= 2;
				*lpwszTemp++ = utf16;
			} else if (utf8 < 0xF8) { // 4oCgUTF8: 0xF0`0xF7
				// BMP͈̔͊O: Ƃ肠
				pData += 3;
				nLen  -= 3;
				*lpwszTemp++ = L'?';
			} else { // 肦Ȃ: 0xF8`0xFF
				*lpwszTemp++ = L'?';
			}
		}
		*lpwszTemp = L'\0';
	}

	setlocale( LC_ALL, "Japanese_Japan.932" );
    wcstombs( lpszTextBuff, wszBuff, nTextBuffSize );

	return pData;
}

// {[Indexlo
long cPMDModel::getPmxBoneIndex(void *pvData)
{
	long nBoneIndex;
	if (m_nExByte[PMX_EX_BONE] == 1) {
		char *pData = (char *)pvData;
		nBoneIndex = *pData;
	} else
	if (m_nExByte[PMX_EX_BONE] == 2) {
		short *pData = (short *)pvData;
		nBoneIndex = *pData;
	} else
	if (m_nExByte[PMX_EX_BONE] == 4) {
		long *pData = (long *)pvData;
		nBoneIndex = *pData;
	}
	return nBoneIndex;
}

// eNX`Indexlo
long cPMDModel::getPmxTexIndex(void *pvData)
{
	long nTexIndex;
	if (m_nExByte[PMX_EX_TEX] == 1) {
		char *pData = (char *)pvData;
		nTexIndex = *pData;
	} else
	if (m_nExByte[PMX_EX_TEX] == 2) {
		short *pData = (short *)pvData;
		nTexIndex = *pData;
	} else
	if (m_nExByte[PMX_EX_TEX] == 4) {
		long *pData = (long *)pvData;
		nTexIndex = *pData;
	}
	return nTexIndex;
}

// _Indexlo
long cPMDModel::getPmxVtxIndex(void *pvData)
{
	long nVtxIndex;
	if (m_nExByte[PMX_EX_VTX] == 1) {
		uchar *pData = (uchar *)pvData; // 
		nVtxIndex = *pData;
	} else
	if (m_nExByte[PMX_EX_VTX] == 2) {
		ushort *pData = (ushort *)pvData; // 
		nVtxIndex = *pData;
	} else
	if (m_nExByte[PMX_EX_VTX] == 4) {
		long *pData = (long *)pvData; // L
		nVtxIndex = *pData;
	}
	return nVtxIndex;
}

// Indexlo
long cPMDModel::getPmxRbIndex(void *pvData)
{
	long nRBIndex;
	if (m_nExByte[PMX_EX_RB] == 1) {
		char *pData = (char *)pvData;
		nRBIndex = *pData;
	} else
	if (m_nExByte[PMX_EX_RB] == 2) {
		short *pData = (short *)pvData;
		nRBIndex = *pData;
	} else
	if (m_nExByte[PMX_EX_RB] == 4) {
		long *pData = (long *)pvData;
		nRBIndex = *pData;
	}
	return nRBIndex;
}


//======================
// PMX ff[^̏
// {IɁAPMDf[^ɕϊāAef[^NXɂłBPMXŗL̃f[^́AقƂǂjĂB
//======================
bool cPMDModel::initializePMX( unsigned char *pData, unsigned long ulDataSize )
{
	unsigned char *pDataTop = pData;

	long nLen;
	unsigned long	ulSize;
	wchar_t szMsg[256];

	// PMX wb_̃`FbN
	PMX_Header	*pPMXHeader = (PMX_Header *)pData;
	pData += sizeof( PMX_Header );

	if( pPMXHeader->szMagic[0] != 'P' || pPMXHeader->szMagic[1] != 'M' || pPMXHeader->szMagic[2] != 'X' || pPMXHeader->szMagic[3] != ' ' )
		return false;	// t@C`Ⴄ

	if( pPMXHeader->fVersion != 2.0f && pPMXHeader->fVersion != 2.1f )
		return false;	// o[WႤ

	memcpy (m_nExByte, pData, 8); // PMXf[^̃Rs[
	pData += pPMXHeader->nExSize;

#if 0
	wsprintf(szMsg, L"len = %08x", (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"hdr", MB_OK);
#endif

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;

	// PMXf̃Rs[
	pData = copyPmxText( pData, m_szModelName, sizeof(m_szModelName) );

	// PMXf(p)̓ǂݔ΂
	nLen = *(long *)pData; // oCgo
	pData += sizeof(long) + nLen;

	// PMXRg̓ǂݔ΂
	nLen = *(long *)pData; // oCgo
	pData += sizeof(long) + nLen;

	// PMXRg(p)̓ǂݔ΂
	nLen = *(long *)pData; // oCgo
	pData += sizeof(long) + nLen;

#if 0
	wsprintf(szMsg, L"len = %08x", (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"name", MB_OK);
#endif

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;


	//-----------------------------------------------------
	// _擾
	m_ulNumVertices = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// _z malloc
	m_pvec3OrgPositionArray  =  (Vector3 *)malloc( sizeof(Vector3)  * m_ulNumVertices );
	m_pvec3OrgPositionArray0 =  (Vector3 *)malloc( sizeof(Vector3)  * m_ulNumVertices );  // \[tp̃obNAbv
	m_pvec3OrgNormalArray    =  (Vector3 *)malloc( sizeof(Vector3)  * m_ulNumVertices );
	m_puvOrgTexureUVArray    =    (TexUV *)malloc( sizeof(TexUV)    * m_ulNumVertices );
	m_pOrgSkinInfoArray      = (SkinInfo *)malloc( sizeof(SkinInfo) * m_ulNumVertices ); 

	// _zRs[
	for( unsigned long i = 0 ; i < m_ulNumVertices ; i++ )
	{
		PMX_Vertex	*pVertex = (PMX_Vertex *)pData;
		pData += sizeof( PMX_Vertex );

		m_pvec3OrgPositionArray [i] =  pVertex->vec3Pos; //  m_clMotionPlayer.update() Ăяoŏ㏑Ă܂̂ŒӁB
		m_pvec3OrgPositionArray0[i] =  pVertex->vec3Pos; // \[tpɑS_f[^ۑĂ
		m_pvec3OrgNormalArray   [i] =  pVertex->vec3Normal;
		m_puvOrgTexureUVArray   [i] =  pVertex->uvTex;

		pData += sizeof( Vector4 ) * m_nExByte[PMX_EX_UV]; // ǉUV ͓ǂݔ΂

		m_pOrgSkinInfoArray[i].nWeightType = *pData++; // EFCgό`

		switch (m_pOrgSkinInfoArray[i].nWeightType) { // {[ƃEFCg̍\
		case 0: // BDEF1
			m_pOrgSkinInfoArray[i].unBoneNo[0] = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE];
			m_pOrgSkinInfoArray[i].unBoneNo[1] = -1;
			m_pOrgSkinInfoArray[i].fWeight [0] = 1.0f; // cR͎gȂ
			break;
		case 1: // BDEF2: PMD ̒_f[^ƌ݊
			m_pOrgSkinInfoArray[i].unBoneNo[0] = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE];
			m_pOrgSkinInfoArray[i].unBoneNo[1] = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE];
			m_pOrgSkinInfoArray[i].fWeight [0] = *(float*)pData;			pData += sizeof(float);
			m_pOrgSkinInfoArray[i].fWeight [1] = 1.0f - m_pOrgSkinInfoArray[i].fWeight[0];
			break;
		case 2: // BDEF4
		case 4: // QDEF(PMX2.1g)
			m_pOrgSkinInfoArray[i].unBoneNo[0] = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE];
			m_pOrgSkinInfoArray[i].unBoneNo[1] = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE];
			m_pOrgSkinInfoArray[i].unBoneNo[2] = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE];
			m_pOrgSkinInfoArray[i].unBoneNo[3] = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE];
			m_pOrgSkinInfoArray[i].fWeight [0] = *(float*)pData;			pData += sizeof(float);
			m_pOrgSkinInfoArray[i].fWeight [1] = *(float*)pData;			pData += sizeof(float);
			m_pOrgSkinInfoArray[i].fWeight [2] = *(float*)pData;			pData += sizeof(float);
			m_pOrgSkinInfoArray[i].fWeight [3] = *(float*)pData;			pData += sizeof(float);
			break;
		case 3: // SDEF
			m_pOrgSkinInfoArray[i].unBoneNo[0] = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE];
			m_pOrgSkinInfoArray[i].unBoneNo[1] = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE];
			m_pOrgSkinInfoArray[i].fWeight [0] = *(float*)pData;			pData += sizeof(float);
			m_pOrgSkinInfoArray[i].fWeight [1] = 1.0f - m_pOrgSkinInfoArray[i].fWeight[0];
			pData += 3 * sizeof( Vector3 );  // SDEF-Cl/R0l/R1l ͓ǂݔ΂
			break;
		default:
			// s̃EFCgό`
			wsprintf(szMsg, L"Error: unkWeightType = %d, BoneIndexSize = %d, ulNumVertices = %d, fpos = %08x", m_pOrgSkinInfoArray[i].nWeightType, m_nExByte[PMX_EX_BONE], m_ulNumVertices, (unsigned long)pData - (unsigned long)pDataTop);
			MessageBox(NULL, szMsg, L"vtx", MB_OK);
			return false; // I
		}

		pData += sizeof( float ); // GbW{ ͓ǂݔ΂
	}

#if 0
	wsprintf(szMsg, L"BoneIndexSize = %d, ulNumVertices = %d, len = %08x", m_nExByte[PMX_EX_BONE], m_ulNumVertices, (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"vtx", MB_OK);
#endif

	// XLjOp_z쐬
	m_pvec3PositionArray = (Vector3 *)malloc( sizeof(Vector3) * m_ulNumVertices );
	m_pvec3NormalArray   = (Vector3 *)malloc( sizeof(Vector3) * m_ulNumVertices );

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;


	//-----------------------------------------------------
	// _CfbNX擾
	m_ulNumIndices = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// _CfbNXzRs[
	ulSize = sizeof( unsigned long ) * m_ulNumIndices;
	m_pIndices = (unsigned long *)malloc( ulSize );

	unsigned long *pIndices = m_pIndices;

	switch (m_nExByte[PMX_EX_VTX]) {
	case 1:
		for( unsigned long i = 0 ; i < m_ulNumIndices ; i++ )
		{
			*pIndices++ = *(unsigned char *)pData; // 8bit lA32bit ɕϊȂARs[
			pData += sizeof( unsigned char );
		}
		break;
	case 2:
		for( unsigned long i = 0 ; i < m_ulNumIndices ; i++ )
		{
			*pIndices++ = *(unsigned short *)pData; // 16bit lA32bit ɕϊȂARs[
			pData += sizeof( unsigned short );
		}
		break;
	case 4:
		for( unsigned long i = 0 ; i < m_ulNumIndices ; i++ )
		{
			*pIndices++ = *(unsigned long *)pData; // 32bit lA32bit ɕϊȂARs[BāÂ܂܂ˁB
			pData += sizeof( unsigned long );
		}
		break;
	}

#if 0
	wsprintf(szMsg, L"VtxIndexSize = %d, ulNumIndices = %d, len = %08x", m_nExByte[PMX_EX_VTX], m_ulNumIndices, (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"vtx idx", MB_OK);
#endif

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;


	//-----------------------------------------------------
	// eLX`擾
	m_ulNumTexture = *((unsigned long *)pData);

	pData += sizeof( unsigned long );

	m_pTexInfo = (TexInfo *) malloc (sizeof(TexInfo) * m_ulNumTexture);


	for( unsigned long i = 0 ; i < m_ulNumTexture ; i++ )
	{
		// eLX`Et@C̃Rs[
		pData = copyPmxText( pData, m_pTexInfo[i].m_szFileName, 512 );
	}

#if 0
	wsprintf(szMsg, L"TexCount = %d, len = %08x", m_ulNumTexture, (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"tex", MB_OK);
#endif

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;


	//-----------------------------------------------------
	// }eA擾
	m_ulNumMaterials = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// }eAzRs[
	m_pMaterials = (Material *)malloc( sizeof(Material) * m_ulNumMaterials );

	for( unsigned long i = 0 ; i < m_ulNumMaterials ; i++ )
	{
		// ގ̓ǂݔ΂
		nLen = *(long *)pData; // oCgo
		pData += sizeof(long) + nLen;

		// ގ(p)̓ǂݔ΂
		nLen = *(long *)pData; // oCgo
		pData += sizeof(long) + nLen;

		PMX_Material	*pPMXMaterial = (PMX_Material *)pData;
		pData += sizeof(PMX_Material);

		m_pMaterials[i].col4Diffuse = pPMXMaterial->col4Diffuse;

		m_pMaterials[i].col4Specular.r = pPMXMaterial->col3Specular.r;
		m_pMaterials[i].col4Specular.g = pPMXMaterial->col3Specular.g;
		m_pMaterials[i].col4Specular.b = pPMXMaterial->col3Specular.b;
		m_pMaterials[i].col4Specular.a = 1.0f;

		m_pMaterials[i].col4Ambient.r = pPMXMaterial->col3Ambient.r;
		m_pMaterials[i].col4Ambient.g = pPMXMaterial->col3Ambient.g;
		m_pMaterials[i].col4Ambient.b = pPMXMaterial->col3Ambient.b;
		m_pMaterials[i].col4Ambient.a = 1.0f;

		m_pMaterials[i].fShininess   = pPMXMaterial->fShininess;

		m_pMaterials[i].cbFlags      = pPMXMaterial->cbFlags;


		long  nTextureIndex = getPmxTexIndex(pData);	pData += m_nExByte[PMX_EX_TEX]; // ʏeNX`, eNX`e[u̎QIndex
		long  nSphereIndex  = getPmxTexIndex(pData);	pData += m_nExByte[PMX_EX_TEX]; // XtBAeNX`, eNX`e[u̎QIndex

		uchar nSphereMode   = *pData++; // XtBA[h 0: 1:Z(sph) 2:Z(spa) 3:TueNX`(ǉUV1x,yUVQƂĒʏeNX``s)
		switch (nSphereMode) {
		case 0: // 0:
			// XtBAeNX`ݒ肳ĂĂɂB
			nSphereIndex = -1;
			break;
		case 1: // 1:Z(sph)
		case 2: // 2:Z(spa)
			// LȃXtBA[hȂ̂ŁÂ܂ܒʂB
			break;
		case 3: // TueNX`
			// XtBAeNX`ݒ肳ĂĂɂB
			nSphereIndex = -1;
			wsprintf(szMsg, L"TueNX`͖܂: nSphereIndex = %d, MatCount = %d, TexIndexSize = %d, fpos = %08x", nSphereIndex, m_ulNumMaterials, m_nExByte[PMX_EX_TEX], (unsigned long)pData - (unsigned long)pDataTop);
			MessageBox(NULL, szMsg, L"mat", MB_OK);
			break;
		default:
			// s̃XtBA[h
			wsprintf(szMsg, L"Error: unkSphereMode = %d, MatCount = %d, TexIndexSize = %d, fpos = %08x", nSphereMode, m_ulNumMaterials, m_nExByte[PMX_EX_TEX], (unsigned long)pData - (unsigned long)pDataTop);
			MessageBox(NULL, szMsg, L"mat", MB_OK);
			return false; // I
		}

		char nCommonToonFlag = *pData++; // LToontO 0:pl͌Toon 1:pl͋LToon
		switch (nCommonToonFlag) { // Toon͎̏蔲ŏȂ
		case 0: // TooneNX`, eNX`e[u̎QIndex
			pData += m_nExByte[PMX_EX_TEX];
			break;
		case 1: // LTooneNX`[0`9] -> ꂼ toon01.bmp`toon10.bmp ɑΉ
			pData++;
			break;
		default:
			return false;
		}

		// Ƃ肠Af[^ł
		m_pMaterials[i].uiTexID     = 0xFFFFFFFF;
		m_pMaterials[i].uiSphereID  = 0xFFFFFFFF;
//		m_pMaterials[i].bSphereMap  = false;
		m_pMaterials[i].nSphereMode = 0;

#if 0 // AȂ΂ȂȂ̂ƎvAǂ͕svB
		if (nTextureIndex < 0 && nSphereIndex >= 0) { // ʏeNX`ŁAXtBAeNX`LȎ
			// PMD ݊ɂFŐ̂킩Ȃ
			nTextureIndex = nSphereIndex;
			nSphereIndex  = -1;
			// ʏeLX`XtBAƂĈ悤ɂ
			m_pMaterials[i].bSphereMap = true;
		}
#endif

		// ʏeNX`t@C̓ǂݍ
		if( nTextureIndex >= 0 )
		{
			/* eNX`jbgOɖ߂ */
			glActiveTexture(GL_TEXTURE0);

			m_pMaterials[i].uiTexID  = m_clsTextureList0.getTexture( m_pTexInfo[nTextureIndex].m_szFileName );
			if (m_pMaterials[i].uiTexID == 0xFFFFFFFF) {
				// ǂݍ݂Ɏs
				if (m_pTexInfo[nTextureIndex].m_szFileName[0]) {
//					wsprintf(szMsg, L"Error: TexReadError: TexIndex = %d, fpos = %08x", nTextureIndex, (unsigned long)pData - (unsigned long)pDataTop);
//					MessageBox(NULL, szMsg, L"mat", MB_OK);
					setlocale( LC_ALL, "Japanese_Japan.932" );
					mbstowcs( szMsg, m_pTexInfo[nTextureIndex].m_szFileName, 255 );
					MessageBox(NULL, szMsg, L"Texture Read Error", MB_OK);
					m_pTexInfo[nTextureIndex].m_szFileName[0] = '\0'; // t@CQȏ\Ȃ悤ɂB
				}
			}
		}

		// XtBAeNX`t@C̓ǂݍ
		if( nSphereIndex >= 0 )
		{
			/* eNX`jbgPɐ؂ւ */
			glActiveTexture(GL_TEXTURE1);

			m_pMaterials[i].uiSphereID = m_clsTextureList1.getTexture( m_pTexInfo[nSphereIndex].m_szFileName );
			if (m_pMaterials[i].uiSphereID == 0xFFFFFFFF) {
				// ǂݍ݂Ɏs
				if (m_pTexInfo[nSphereIndex].m_szFileName[0]) {
//					wsprintf(szMsg, L"Error: TexReadError: TexIndex = %d, fpos = %08x", nTextureIndex, (unsigned long)pData - (unsigned long)pDataTop);
//					MessageBox(NULL, szMsg, L"mat", MB_OK);
					setlocale( LC_ALL, "Japanese_Japan.932" );
					mbstowcs( szMsg, m_pTexInfo[nSphereIndex].m_szFileName, 255 );
					MessageBox(NULL, szMsg, L"Texture Read Error", MB_OK);
					m_pTexInfo[nSphereIndex].m_szFileName[0] = '\0'; // t@CQȏ\Ȃ悤ɂB
				}
			} else {
				// ǂݍ߂̂ŁA߂ăXtBA[hݒ肷
				m_pMaterials[i].nSphereMode = nSphereMode;
			}
		}

		// ̓ǂݔ΂
		nLen = *(long *)pData; // oCgo
		pData += sizeof(long) + nLen;

		m_pMaterials[i].ulNumIndices = *(long *)pData; // ގɑΉ(_) (K3̔{ɂȂ)
		pData += sizeof(long);
	}

#if 0
	wsprintf(szMsg, L"MatCount = %d, TexIndexSize = %d, len = %08x", m_ulNumMaterials, m_nExByte[PMX_EX_TEX], (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"mat", MB_OK);
#endif

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;

	/* eNX`jbgOɖ߂ */
	glActiveTexture(GL_TEXTURE0);


	//-----------------------------------------------------
	// {[擾
	m_unNumBones = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// 蔲: short͈̔͂Ŏ܂Ȃ͋I
	if (m_unNumBones > 0x7FFF) {
		wsprintf(szMsg, L"Error: {[܂(32767܂): BoneCount = %d, BoneIndexSize = %d, len = %08x", m_unNumBones, m_nExByte[PMX_EX_BONE], (unsigned long)pData - (unsigned long)pDataTop);
		MessageBox(NULL, szMsg, L"bone", MB_OK);
		return false;
	}

	// {[z쐬
	m_pBoneArray = new cPMDBone[m_unNumBones];

	m_nMaxBoneTransLevel = 0; // {[̍őό`Kw

	PMX_Bone pmxBone;

	// IK͂Ƃ肠OɂĂ
	m_unNumIK = 0;
	PMX_IK *pmxIkList = (PMX_IK *) malloc (64 * sizeof(PMX_IK)); // IKXgF蔲ōő64ɌŒB{ vector ƂgׂB

	for( unsigned long i = 0 ; i < m_unNumBones ; i++ )   // {[z̏́A_ł͐ɍ쐬ĂȂBKB
	{
		// {[̃Rs[
		char szBoneName[32]; // {[: *.vmd ̕ő15܂łȂ̂ŁA32mۂĂΏ\낤BB
		pData = copyPmxText( pData, szBoneName, 32 );

		// {[(p)̓ǂݔ΂
		nLen = *(long *)pData; // oCgo
		pData += sizeof(long) + nLen;

		// UAS 0 
		memset (&pmxBone, 0, sizeof(PMX_Bone));

		memcpy (&pmxBone.vec3Position, pData, sizeof(Vector3)); // f_̈ʒu
		pData += sizeof(Vector3);

		pmxBone.nParentNo      = getPmxBoneIndex(pData); // e{[̃{[Index
		pData += m_nExByte[PMX_EX_BONE]; 
		pmxBone.nChildNo       = -1; // q{[ԍ: Ƃ肠Aڑ斳(-1)AĂ
		pmxBone.nGrantParentNo = -1; // t^e{[ԍ: Ƃ肠Aڑ斳(-1)AĂ

		long nTransLevel = *(long *)pData;		// ό`Kw
		pData += sizeof(long);
		if (m_nMaxBoneTransLevel < nTransLevel) { // {[̍őό`Kw̍XV
			m_nMaxBoneTransLevel = nTransLevel;
		}

		pmxBone.nBoneFlags = *(ushort *)pData; // {[tO(16bit)
		pData += sizeof(ushort);

		if (pmxBone.nBoneFlags & PMX_BONE_FLAG_TGT_TYP) { // ڑ(PMDq{[w)\@
			pmxBone.nChildNo = getPmxBoneIndex(pData); // ڑ{[̃{[Index
			pData += m_nExByte[PMX_EX_BONE];
		} else {
			// WItZbg, {[ʒȗΕ ́A*.vmd Đɂ͕svȂ̂ŁAƂ肠
			pData += sizeof(Vector3); 
		}

		if (pmxBone.nBoneFlags & (PMX_BONE_FLAG_ROT_GRANT | PMX_BONE_FLAG_MOV_GRANT) ) { // ]t^:1 ܂ ړt^:1 ̏ꍇ
			pmxBone.nGrantParentNo = getPmxBoneIndex(pData); // t^e{[̃{[Index
			pData += m_nExByte[PMX_EX_BONE];
			pmxBone.fGrantRatio = *(float *)pData; // t^
			pData += sizeof(float);
		}

		if (pmxBone.nBoneFlags & PMX_BONE_FLAG_AXIS_LIMIT ) { // Œ:1 ̏ꍇ
			pmxBone.vec3AxisLimitDir = *(Vector3 *)pData; // Œ̕xNg
			pData += sizeof(Vector3); 
		}

		if (pmxBone.nBoneFlags & PMX_BONE_FLAG_LOCAL ) { // [J:1 ̏ꍇ
			pmxBone.vec3LocalXDir = *(Vector3 *)pData; // [JX̕xNg
			pData += sizeof(Vector3); 
			pmxBone.vec3LocalZDir = *(Vector3 *)pData; // [JZ̕xNg
			pData += sizeof(Vector3); 
		}

		if (pmxBone.nBoneFlags & PMX_BONE_FLAG_EX_P_TRANS ) { // Oeό`:1 ̏ꍇ
			pmxBone.nKey = *(long *)pData; // Oeό`Keyl
			pData += sizeof(long); 
		}

		if (pmxBone.nBoneFlags & PMX_BONE_FLAG_IK ) { // IK:1 ̏ꍇ IKf[^i[
			pmxIkList[m_unNumIK].nTargetNo = i; // IK^[Qbg{[ԍ
			pmxIkList[m_unNumIK].nEffNo    = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE]; // IK[{[ԍ
			pmxIkList[m_unNumIK].unCount   = *(ulong *)pData;			pData += sizeof(ulong);		// ċAZ // IKl1
			pmxIkList[m_unNumIK].fFact     = *(float *)pData / 4.0f;	pData += sizeof(float);		// Z1񂠂̐px // IKl2  PMD݊lɂɂ́A4.0ŊKv͗l
			pmxIkList[m_unNumIK].cbNumLink = *(ulong *)pData;			pData += sizeof(ulong);		// IK\{[̐
			
			if (pmxIkList[m_unNumIK].cbNumLink >= 256) {
				// 256ȏȂAxoA{[z͍쐬ȂB
				wsprintf(szMsg, L"%d^[QbgƂIK\{[̐܂BBoneCount = %d, BoneIndexSize = %d, len = %08x", i, m_unNumBones, m_nExByte[PMX_EX_BONE], (unsigned long)pData - (unsigned long)pDataTop);
				MessageBox(NULL, szMsg, L"bone", MB_OK);
			} else {
				// 256Ȃ{[z쐬
				for (ulong j = 0; j < pmxIkList[m_unNumIK].cbNumLink; j++) {
					pmxIkList[m_unNumIK].punLinkNo[j] = getPmxBoneIndex(pData);	pData += m_nExByte[PMX_EX_BONE]; // IK\{[
					char nAngleLimit = *pData++; // px 0:OFF 1:ON
					if (nAngleLimit) { // px:1̏ꍇ
						pData += 2 * sizeof(Vector3);  // ǂݔ΂
					}
				}

				m_unNumIK++;
				if (m_unNumIK > 64) { // 蔲
					wsprintf(szMsg, L"Error: IkListMax: IkCount = %d, fpos = %08x", m_unNumIK, (unsigned long)pData - (unsigned long)pDataTop);
					MessageBox(NULL, szMsg, L"bone", MB_OK);
					free (pmxIkList);
					return false;
				}
			}
		}

		m_pBoneArray[i].initialize( szBoneName, &pmxBone, m_pBoneArray );

		// ̃{[ۑ
		if( strncmp( m_pBoneArray[i].getName(), "", 20 ) == 0 )	m_pNeckBone = &m_pBoneArray[i];
	}

	// ẽ{[ԍ̂ق傫ꍇɂȂ̂ŏIɍČvZ
	for( unsigned long i = 0 ; i < m_unNumBones ; i++ ) {
		m_pBoneArray[i].recalcOffset();
	}


#if 0
	wsprintf(szMsg, L"BoneCount = %d, BoneIndexSize = %d, len = %08x", m_unNumBones, m_nExByte[PMX_EX_BONE], (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"bone", MB_OK);
#endif

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;


	// IKz쐬
	if( m_unNumIK )
	{
		m_pIKArray = new cPMDIK[m_unNumIK];

		for( unsigned short i = 0 ; i < m_unNumIK ; i++ )
		{
			m_pIKArray[i].initialize( &pmxIkList[i], m_pBoneArray );
		}
		qsort( m_pIKArray, m_unNumIK, sizeof(cPMDIK), compareFunc );
	}

	free (pmxIkList);


	//-----------------------------------------------------
	// \擾
	// ̎_ł́A\ȊÕ[t܂߂ɂȂĂ
	m_unNumFaces = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	ulong nVtxCount = 0; // \̐_[t

	// \z쐬
	if( m_unNumFaces )
	{
		m_pFaceArray = new cPMDFace[m_unNumFaces];

		for( unsigned long i = 0 ; i < m_unNumFaces ; i++ )
		{
			// [t̃Rs[
			char szMorphName[256]; // [t
			pData = copyPmxText( pData, szMorphName, 256 );

			// [t(p)̓ǂݔ΂
			nLen = *(long *)pData; // oCgo
			pData += sizeof(long) + nLen;

			// pmx[tf[^APMD\f[^ɕϊĂBPMD\ɖ[tf[^́AƂ肠B

			uchar nCategory   = *pData++;  // pl (PMD:JeS) 1:() 2:() 3:(E) 4:̑(E)  | 0:VXe\
			uchar nMorphType  = *pData++;  // [t - 0:O[v, 1:_, 2:{[, 3:UV, 4:ǉUV1, 5:ǉUV2, 6:ǉUV3, 7:ǉUV4, 8:ގ
			ulong nNumElement = *(ulong *)pData; // [t̃ItZbg : 㑱̗vf
			pData += sizeof(ulong);

			switch (nMorphType) {
			case 0: // O[v
			case 9: // tbv(PMX2.1g)
				// ǂݔ΂
				pData += (m_nExByte[PMX_EX_MORPH] + sizeof(float)) * nNumElement;
				break;
			case 1: // _
				if (1) { // assertNoOACłB
					PMD_Face *pPmdFace = (PMD_Face *)malloc(sizeof(PMD_Face) + (nNumElement-1) * sizeof(PMD_FaceVtx)); // PMD\f[^݊
					if (pPmdFace) {
						pPmdFace->ulNumVertices = nNumElement;
						pPmdFace->cbType        = nCategory;
						for( ulong j = 0 ; j < nNumElement; j++ ) {
							pPmdFace->pVertices[j].ulIndex = getPmxVtxIndex(pData);	// _Index
							pData += m_nExByte[PMX_EX_VTX];
							memcpy (&pPmdFace->pVertices[j].vec3Pos, pData, sizeof(Vector3) ); // WItZbg(x,y,z)
							pData += sizeof(Vector3);
						}
						m_pFaceArray[nVtxCount].initialize( szMorphName, pPmdFace, NULL, m_pvec3OrgPositionArray ); // Wzɐ΍WvZ
						nVtxCount++;
						free (pPmdFace);
					}
				} else {
					// ǂݔ΂
					pData += (m_nExByte[PMX_EX_VTX] + sizeof(Vector3)) * nNumElement;
				}
				break;
			case 2: // {[
				// ǂݔ΂
				pData += (m_nExByte[PMX_EX_BONE] + sizeof(Vector3) + sizeof(Vector4)) * nNumElement;
				break;
			case 3: // UV
			case 4: // ǉUV1
			case 5: // ǉUV2
			case 6: // ǉUV3
			case 7: // ǉUV4
				// ǂݔ΂
				pData += (m_nExByte[PMX_EX_VTX] + sizeof(Vector4)) * nNumElement;
				break;
			case 8: // ގ
//				wsprintf(szMsg, L"MatMorph: FaceCount = %d, len = %08x", m_unNumFaces, (unsigned long)pData - (unsigned long)pDataTop);
//				MessageBox(NULL, szMsg, L"face", MB_OK);
				// ǂݔ΂
				pData += (m_nExByte[PMX_EX_MAT] + 1 + 2 * sizeof(float) + 2 * sizeof(Vector3) + 5 * sizeof(Vector4)) * nNumElement;
				break;
			case 10: // CpX(PMX2.1g)
				// ǂݔ΂
				pData += (m_nExByte[PMX_EX_RB] + 1 + 2 * sizeof(Vector3)) * nNumElement;
				break;
			default:
				wsprintf(szMsg, L"Error: unkMorphType = %d, FaceCount = %d, len = %08x", nMorphType, m_unNumFaces, (unsigned long)pData - (unsigned long)pDataTop);
				MessageBox(NULL, szMsg, L"face", MB_OK);
				return false;
			}
		}
	}


#if 0
	wsprintf(szMsg, L"FaceCount = %d, nVtxCount = %d, len = %08x", m_unNumFaces, nVtxCount, (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"face", MB_OK);
#endif

	// \[t̐ɒuB̃[tLɂȂAɉZKvBȀꍇłʕϐɂǂB
	m_unNumFaces = nVtxCount;
	if (m_unNumFaces == 0) { // 0烁Ă
		if( m_pFaceArray )
		{
			delete [] m_pFaceArray;
			m_pFaceArray = NULL;
		}
	}


	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;



	//-----------------------------------------------------
	// 獄̏܂œǂݔ΂

	// \gp\Xg
	unsigned long	cbFaceDispNum = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	for( unsigned long i = 0 ; i < cbFaceDispNum ; i++ )
	{
		// g̓ǂݔ΂
		nLen = *(long *)pData; // oCgo
		pData += sizeof(long) + nLen;

		// g(p)̓ǂݔ΂
		nLen = *(long *)pData; // oCgo
		pData += sizeof(long) + nLen;

		pData++; // gtO - 0:ʏg 1:g

		ulong nNumElement = *(ulong *)pData; // gvf : 㑱̗vf
		pData += sizeof(ulong);

		for( ulong j = 0 ; j < nNumElement; j++ ) {
			byte nType = *pData++; // vfΏ 0:{[ 1:[t
			if (nType == 0) {
				pData += m_nExByte[PMX_EX_BONE];
			} else {
				pData += m_nExByte[PMX_EX_MORPH];
			}
		}
	}


#if 0
	wsprintf(szMsg, L"FaceDispCount = %d, len = %08x", cbFaceDispNum, (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"disp", MB_OK);
#endif

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;


#if 0 // ̂ŁAƂ肠ZȂ

	//-----------------------------------------------------
	// ̐擾
	m_ulRigidBodyNum = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// ̔z쐬
	if( m_ulRigidBodyNum )
	{
		m_pRigidBodyArray = new cPMDRigidBody[m_ulRigidBodyNum];

		for( unsigned long i = 0 ; i < m_ulRigidBodyNum ; i++ )
		{
			// ̖̓ǂݔ΂
			nLen = *(long *)pData; // oCgo
			pData += sizeof(long) + nLen;

			// ̖(p)̓ǂݔ΂
			nLen = *(long *)pData; // oCgo
			pData += sizeof(long) + nLen;

			long nBoneIndex = getPmxBoneIndex(pData);	// ֘A{[ԍ
			pData += m_nExByte[PMX_EX_BONE];

			const PMD_RigidBody *pPMDRigidBody = (const PMD_RigidBody *)pData;
			pData += sizeof( PMD_RigidBody );

			cPMDBone	*pBone = NULL;
			if( nBoneIndex == -1 )	pBone = getBoneByName( "Z^[" );
			else					pBone = &m_pBoneArray[nBoneIndex];
			
			if (pBone == NULL) {
				wsprintf(szMsg, L"NotFound %d: RigidBodyCount = %d, len = %08x", nBoneIndex, m_ulRigidBodyNum, (unsigned long)pData - (unsigned long)pDataTop);
				MessageBox(NULL, szMsg, L"RigidBody", MB_OK);
			}

			m_pRigidBodyArray[i].initialize( nBoneIndex, pPMDRigidBody, pBone );
		}
	}

#if 0
	wsprintf(szMsg, L"RigidBodyCount = %d, len = %08x", m_ulRigidBodyNum, (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"RigidBody", MB_OK);
#endif

	// 㑱f[^̗L`FbN
	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;



	//-----------------------------------------------------
	// RXgCg擾
	m_ulConstraintNum = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// RXgCgz쐬
	if( m_ulConstraintNum )
	{
		m_pConstraintArray = new cPMDConstraint[m_ulConstraintNum];

		for( unsigned long i = 0 ; i < m_ulConstraintNum ; i++ )
		{
			// Joint̓ǂݔ΂
			nLen = *(long *)pData; // oCgo
			pData += sizeof(long) + nLen;

			// Joint(p)̓ǂݔ΂
			nLen = *(long *)pData; // oCgo
			pData += sizeof(long) + nLen;

			uchar nJointType = *pData++; // Joint - 0:XvO6DOF   | PMX2.0ł 0 ̂(gp)

			long lRigidA = getPmxRbIndex(pData);		// A
			pData += m_nExByte[PMX_EX_RB];
			long lRigidB = getPmxRbIndex(pData);		// B
			pData += m_nExByte[PMX_EX_RB];

			const PMD_Constraint *pPMDConstraint = (const PMD_Constraint *)pData;
			pData += sizeof( PMD_Constraint );

			cPMDRigidBody	*pRigidBodyA = (lRigidA < 0) ? NULL : &m_pRigidBodyArray[lRigidA];
			cPMDRigidBody	*pRigidBodyB = (lRigidB < 0) ? NULL : &m_pRigidBodyArray[lRigidB];

			if (pRigidBodyA && pRigidBodyB) {
				m_pConstraintArray[i].initialize( pPMDConstraint, pRigidBodyA, pRigidBodyB );
			}
		}
	}

#if 0
	wsprintf(szMsg, L"JointCount = %d, len = %08x", m_ulConstraintNum, (unsigned long)pData - (unsigned long)pDataTop);
	MessageBox(NULL, szMsg, L"joint", MB_OK);
#endif

//	// 㑱f[^̗L`FbN
//	if( (unsigned long)pData - (unsigned long)pDataTop >= ulDataSize )	return false;



//------------------------------------------
// SoftBody (PMX2.1̐VKǉ) ͏ȗ
//------------------------------------------

#endif

	return true;
}

//----------------------------------------------
// XtBA}bvp̃eNX`ǂԂ
//----------------------------------------------
bool cPMDModel::isSphereMapTexName( const char *szTextureName, bool bAdd )
{
	int		iLen = strlen( szTextureName );
	bool	bRet = false;

	if (bAdd) { 
		// Zt@C
		if( 	(szTextureName[iLen - 3] == 's' || szTextureName[iLen - 3] == 'S') &&
				(szTextureName[iLen - 2] == 'p' || szTextureName[iLen - 2] == 'P') &&
				(szTextureName[iLen - 1] == 'a' || szTextureName[iLen - 1] == 'A')		)
		{
			bRet = true;
		}
	} else {
		// Zt@C
		if( 	(szTextureName[iLen - 3] == 's' || szTextureName[iLen - 3] == 'S') &&
				(szTextureName[iLen - 2] == 'p' || szTextureName[iLen - 2] == 'P') &&
				(szTextureName[iLen - 1] == 'h' || szTextureName[iLen - 1] == 'H')		)
		{
			bRet = true;
		}
	}

	return bRet;
}

//======================
// w薼̃{[Ԃ
//======================
cPMDBone *cPMDModel::getBoneByName( const char *szBoneName )
{
	cPMDBone *pBoneArray = m_pBoneArray;
	for( unsigned long i = 0 ; i < m_unNumBones ; i++, pBoneArray++ )
	{
		if( strncmp( pBoneArray->getName(), szBoneName, 20 ) == 0 )
			return pBoneArray;
	}

	return NULL;
}

//====================
// w薼̕\Ԃ
//====================
cPMDFace *cPMDModel::getFaceByName( const char *szFaceName )
{
	cPMDFace *pFaceArray = m_pFaceArray;
	for( unsigned long i = 0 ; i < m_unNumFaces ; i++, pFaceArray++ )
	{
		if( strncmp( pFaceArray->getName(), szFaceName, 20 ) == 0 )
			return pFaceArray;
	}

	return NULL;
}

//====================
// [ṼZbg
//====================
void cPMDModel::setMotion( cVMDMotion *pVMDMotion, bool bLoop, float fInterpolateFrame )
{
	m_clMotionPlayer.setup( this, pVMDMotion, bLoop, fInterpolateFrame );
}

//==========================================
// ̂̈ʒũ݂{[̈ʒuɂ킹
//==========================================
void cPMDModel::resetRigidBodyPos( void )
{
	for( unsigned long i = 0 ; i < m_ulRigidBodyNum ; i++ )
	{
		m_pRigidBodyArray[i].moveToBonePos();
	}
}

//==============================
// [Vɂ{[̍XV
// ZÕ{[ό`
//==============================
bool cPMDModel::updateMotion( float fElapsedFrame )
{
	bool	bMotionEnd = false;

	// [VXVOɕ\Zbg
	if (m_bPmx) {
		// PMX ̏ꍇAbase\f[^̂ŁAĂǂݍݎ̑S_f[^㏑Rs[
		memcpy (m_pvec3OrgPositionArray, m_pvec3OrgPositionArray0, sizeof(Vector3) * m_ulNumVertices);
	} else {
		// PMD ̏ꍇAbase\f[^(m_pFaceArray[0])L̂ŁAꂾ㏑OKB
		if( m_pFaceArray)	m_pFaceArray[0].setFace( m_pvec3OrgPositionArray );
	}

	// [VXV
	bMotionEnd = m_clMotionPlayer.update( fElapsedFrame );

	// {[s̍XV
#if 01
	// ̃[`
	for( unsigned long i = 0 ; i < m_unNumBones ; i++ )
	{
		m_pBoneArray[i].updateMatrix();
	}
#else
	// eXg: IKO
	for( unsigned long i = 0 ; i < m_unNumBones ; i++ )
	{
//		if (!(m_pBoneArray[i].getBoneFlags() & PMX_BONE_FLAG_PHY_TRANS)) { // ό` == OFF  ON ͕̎ZɎ{
			if (m_pBoneArray[i].getTransLevel() == 0) { // ό`Kw0Kw̃{[̂
				m_pBoneArray[i].updateMatrix();
			}
		}
	}
#endif

#if 0 // ʒuړ
	// {[ʒu킹
	for( unsigned long i = 0 ; i < m_ulRigidBodyNum ; i++ )
	{
		m_pRigidBodyArray[i].fixPosition( fElapsedFrame );
	}
#endif

#if 01
	// IK̍XV
	// V[eBOX^[.vmd ́A𖳌ɂƖ\ȂȂBARhjsȂȂĂ܂B
	for( unsigned short i = 0 ; i < m_unNumIK ; i++ )
	{
		m_pIKArray[i].update();
	}
#endif

#if 0
	// eXg: IK
	// {[̍őό`KwA񂷁Bm_nMaxBoneTransLevelԖڂ܂߂BRȂAP`R̂RsB
	for (long nBoneTransLevel = 1; nBoneTransLevel <= m_nMaxBoneTransLevel; nBoneTransLevel++)
	{
		for( unsigned long i = 0 ; i < m_unNumBones ; i++ )
		{
//			if (!(m_pBoneArray[i].getBoneFlags() & PMX_BONE_FLAG_PHY_TRANS)) { // ό` == OFF  ON ͕̎ZɎ{
				if (m_pBoneArray[i].getTransLevel() == nBoneTransLevel) { // ό`Kwv{[̂
					m_pBoneArray[i].updateMatrix();
				}
//			}
		}
	}
#endif

#if 01 // ʒuړ
	// {[ʒu킹
	for( unsigned long i = 0 ; i < m_ulRigidBodyNum ; i++ )
	{
		m_pRigidBodyArray[i].fixPosition( fElapsedFrame );
	}
#endif

	return bMotionEnd;
}

//==============================
// [Vɂ{[̍XV
// Z̃{[ό`: pmxf̂
//==============================
bool cPMDModel::updateMotionAfterBullet( float fElapsedFrame )
{
#if 0
	// ŗǂ̂eXgĂȂ
	for( unsigned long i = 0 ; i < m_unNumBones ; i++ )
	{
		if (m_pBoneArray[i].getBoneFlags() & PMX_BONE_FLAG_PHY_TRANS) { // ό` == ON
			m_pBoneArray[i].updateMatrix();
		}
	}
#endif

	return true;
}


//================================
// ̃{[^[QbgɌ
//================================
void cPMDModel::updateNeckBone( const Vector3 *pvec3LookTarget, float fLimitXD, float fLimitXU, float fLimitY )
{
	if( m_pNeckBone && m_bLookAt )
	{
		m_pNeckBone->lookAt( pvec3LookTarget, fLimitXD, fLimitXU, fLimitY );

		unsigned long i;
		for( i = 0 ; i < m_unNumBones ; i++ )
		{
			if( m_pNeckBone == &m_pBoneArray[i] )	break;
		}

		for( ; i < m_unNumBones ; i++ )
		{
			m_pBoneArray[i].updateMatrix();
		}
	}
}

//====================
// _XLjO
//====================
void cPMDModel::updateSkinning( void )
{
	// Zf
	for( unsigned long i = 0 ; i < m_ulRigidBodyNum ; i++ )
	{
		m_pRigidBodyArray[i].updateBoneTransform();
	}

	// XLjOps̍XV
	for( unsigned long i = 0 ; i < m_unNumBones ; i++ )
	{
		m_pBoneArray[i].updateSkinningMat();
	}

	// _XLjO
	Matrix	matTemp;
	for( unsigned long i = 0 ; i < m_ulNumVertices ; i++ )
	{
		if( m_pOrgSkinInfoArray[i].fWeight[0] >= 0.9999f ) // BDEF1͏ɂB܂́ABDEF2, BDEF4, SDEF, QDEF ̓ȏꍇ̂
		{
			Vector3Transform( &m_pvec3PositionArray[i], &m_pvec3OrgPositionArray[i], m_pBoneArray[m_pOrgSkinInfoArray[i].unBoneNo[0]].m_matSkinning );
			Vector3Rotate   ( &m_pvec3NormalArray  [i], &m_pvec3OrgNormalArray  [i], m_pBoneArray[m_pOrgSkinInfoArray[i].unBoneNo[0]].m_matSkinning );
		}
		else if( m_pOrgSkinInfoArray[i].fWeight[1] >= 0.9999f ) // BDEF2, BDEF4, SDEF, QDEF ̓ȏꍇ̂
		{
			Vector3Transform( &m_pvec3PositionArray[i], &m_pvec3OrgPositionArray[i], m_pBoneArray[m_pOrgSkinInfoArray[i].unBoneNo[1]].m_matSkinning );
			Vector3Rotate   ( &m_pvec3NormalArray  [i], &m_pvec3OrgNormalArray  [i], m_pBoneArray[m_pOrgSkinInfoArray[i].unBoneNo[1]].m_matSkinning );
		}
		else
		{
			if (m_pOrgSkinInfoArray[i].nWeightType == 2 || m_pOrgSkinInfoArray[i].nWeightType == 4) { // BDEF4, QDEF ̏ꍇ
				// ȉ́ABDEF4 ̏BQDEF̎Ȁŗǂ̂킩ȂB
				MatrixLerp4( matTemp,	m_pBoneArray[m_pOrgSkinInfoArray[i].unBoneNo[0]].m_matSkinning,
										m_pBoneArray[m_pOrgSkinInfoArray[i].unBoneNo[1]].m_matSkinning,
										m_pBoneArray[m_pOrgSkinInfoArray[i].unBoneNo[2]].m_matSkinning,
										m_pBoneArray[m_pOrgSkinInfoArray[i].unBoneNo[3]].m_matSkinning,
										m_pOrgSkinInfoArray[i].fWeight[0],
										m_pOrgSkinInfoArray[i].fWeight[1],
										m_pOrgSkinInfoArray[i].fWeight[2],
										m_pOrgSkinInfoArray[i].fWeight[3] );
			} else { // BDEF2, SDEF ̏ꍇ
				MatrixLerp( matTemp,	m_pBoneArray[m_pOrgSkinInfoArray[i].unBoneNo[0]].m_matSkinning,
										m_pBoneArray[m_pOrgSkinInfoArray[i].unBoneNo[1]].m_matSkinning,		m_pOrgSkinInfoArray[i].fWeight[0] );
			}

			Vector3Transform( &m_pvec3PositionArray[i], &m_pvec3OrgPositionArray[i], matTemp );
			Vector3Rotate   ( &m_pvec3NormalArray  [i], &m_pvec3OrgNormalArray  [i], matTemp );
		}
	}
}

//====================
// ff[^̕`
// v1.12: ʏeLX`ƃXtBAeLX`̏ZEZẐ߁AeNX`jbg𓱓B
//====================
void cPMDModel::render( void )
{
	if( !m_pvec3OrgPositionArray )	return;

//	unsigned short	*pIndices = m_pIndices;
	unsigned long	*pIndices = m_pIndices;

	glEnableClientState( GL_VERTEX_ARRAY );
	glEnableClientState( GL_NORMAL_ARRAY );
//	glEnableClientState( GL_TEXTURE_COORD_ARRAY );

	// _WA@AeNX`W̊ezZbg
	glVertexPointer  ( 3, GL_FLOAT, 0, m_pvec3PositionArray );
	glNormalPointer  (    GL_FLOAT, 0, m_pvec3NormalArray );
//	glTexCoordPointer( 2, GL_FLOAT, 0, m_puvOrgTexureUVArray );

	/* eNX`jbgPɐ؂ւ */
	glActiveTexture(GL_TEXTURE1);
	glClientActiveTexture(GL_TEXTURE1);

	// eNX`jbgɐݒ肷KvH
	glEnableClientState( GL_TEXTURE_COORD_ARRAY );
	glTexCoordPointer( 2, GL_FLOAT, 0, m_puvOrgTexureUVArray );

	// eNX`̃Iy[Vݒ
	glTexEnvi(GL_TEXTURE_ENV, GL_SRC0_RGB,         GL_TEXTURE);
	glTexEnvi(GL_TEXTURE_ENV, GL_OPERAND0_RGB,     GL_SRC_COLOR);
	glTexEnvi(GL_TEXTURE_ENV, GL_SRC1_RGB,         GL_PREVIOUS);
	glTexEnvi(GL_TEXTURE_ENV, GL_OPERAND1_RGB,     GL_SRC_COLOR);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE);
//	glTexEnvi(GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_MODULATE); // Őݒ肷

	glTexGeni( GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP );
	glTexGeni( GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP );

	/* eNX`jbgOɖ߂ */
	glActiveTexture(GL_TEXTURE0);
	glClientActiveTexture(GL_TEXTURE0);

	// eNX`jbgɐݒ肷KvH
	glEnableClientState( GL_TEXTURE_COORD_ARRAY );
	glTexCoordPointer( 2, GL_FLOAT, 0, m_puvOrgTexureUVArray );

	glTexGeni( GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP );
	glTexGeni( GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP );

	glDisable( GL_CULL_FACE );

	for( unsigned long i = 0 ; i < m_ulNumMaterials ; i++ )
	{
		// }eAݒ
		glMaterialfv( GL_FRONT_AND_BACK, GL_DIFFUSE,  (float *)&(m_pMaterials[i].col4Diffuse)  );
		glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT,  (float *)&(m_pMaterials[i].col4Ambient)  );
		glMaterialfv( GL_FRONT_AND_BACK, GL_SPECULAR, (float *)&(m_pMaterials[i].col4Specular) );
		glMaterialf(  GL_FRONT_AND_BACK, GL_SHININESS, m_pMaterials[i].fShininess );

		//if( m_pMaterials[i].col4Diffuse.a < 1.0f )	glDisable( GL_CULL_FACE );
		//else											glEnable( GL_CULL_FACE );

		if (m_pMaterials[i].cbFlags & PMX_MAT_FLAG_BOTH) { // ʕ`
			glDisable(GL_CULL_FACE);
		} else { // \ʂ̂
			glEnable(GL_CULL_FACE);
//			glCullFace(GL_FRONT);
		}

		/* eNX`jbgOɖ߂ */
		glActiveTexture(GL_TEXTURE0);
		glClientActiveTexture(GL_TEXTURE0);

		if( m_pMaterials[i].uiTexID != 0xFFFFFFFF )
		{
			// ʏeNX`ȂBind
			glEnable( GL_TEXTURE_2D );
			glBindTexture( GL_TEXTURE_2D, m_pMaterials[i].uiTexID );

//			if( m_pMaterials[i].bSphereMap )
//			{
//				glEnable( GL_TEXTURE_GEN_S );
//				glEnable( GL_TEXTURE_GEN_T );
//			}
//			else
//			{
				glDisable( GL_TEXTURE_GEN_S );
				glDisable( GL_TEXTURE_GEN_T );
//			}
		}
		else
		{
			// ʏeNX`Ȃ
			glDisable( GL_TEXTURE_2D );
		}

#if 01 // Lɂ
		/* eNX`jbgPɐ؂ւ */
		glActiveTexture(GL_TEXTURE1);
		glClientActiveTexture(GL_TEXTURE1);

		if( m_pMaterials[i].uiSphereID != 0xFFFFFFFF )
		{
			// XtBAEeNX`ȂBind
			glEnable( GL_TEXTURE_2D );
			glBindTexture( GL_TEXTURE_2D, m_pMaterials[i].uiSphereID );

			glEnable( GL_TEXTURE_GEN_S );
			glEnable( GL_TEXTURE_GEN_T );

			if (m_pMaterials[i].nSphereMode == 2) { // XtBAZ
//				glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD); // GL_TEXTURE_ENV_MODE == GL_COMBINE Ŗ͂H

//				glTexEnvi(GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_REPLACE); // ꂾƑSZȂȂ

				glTexEnvi(GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_ADD); // тꍇ  ō\Ȃ͗l

//				glTexEnvi(GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_INTERPOLATE); // ĂQŊ
//				static const GLfloat blend[] = { 1.0, 1.0, 1.0, 0.5 }; // X
//				glTexEnvfv(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, blend); // blendŉZ̊w肷
			} else { // XtBAZ
//				glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); // GL_TEXTURE_ENV_MODE == GL_COMBINE Ŗ͂H
				glTexEnvi(GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_MODULATE); // ꂾ낤
			}
		}
		else
		{
			// XtBAEeNX`Ȃ
			glDisable( GL_TEXTURE_2D );
			glTexEnvi(GL_TEXTURE_ENV, GL_COMBINE_RGB, GL_REPLACE); // eNX`jbgPeȂ
		}
#endif

		// _CfbNXw肵ă|S`
//		glDrawElements( GL_TRIANGLES, m_pMaterials[i].ulNumIndices, GL_UNSIGNED_SHORT, pIndices );
		glDrawElements( GL_TRIANGLES, m_pMaterials[i].ulNumIndices, GL_UNSIGNED_INT,   pIndices );

		pIndices += m_pMaterials[i].ulNumIndices;
	}

	/* eNX`jbgPɐ؂ւ */
	glActiveTexture(GL_TEXTURE1);
	glClientActiveTexture(GL_TEXTURE1);

	glDisable( GL_TEXTURE_GEN_S );
	glDisable( GL_TEXTURE_GEN_T );
	glDisable( GL_TEXTURE_2D );  // ĂȂƁArenderɉ摜ŜɃGtFNg|Ă܂ꍇ

	/* eNX`jbgOɖ߂ */
	glActiveTexture(GL_TEXTURE0);
	glClientActiveTexture(GL_TEXTURE0);

	glDisable( GL_TEXTURE_GEN_S );
	glDisable( GL_TEXTURE_GEN_T );

	glDisableClientState( GL_VERTEX_ARRAY );
	glDisableClientState( GL_NORMAL_ARRAY );
	glDisableClientState( GL_TEXTURE_COORD_ARRAY );

#if	_DBG_BONE_DRAW
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_LIGHTING );

	for( unsigned long i = 0 ; i < m_unNumBones ; i++ )
	{
		m_pBoneArray[i].debugDraw();
	}

	glEnable( GL_DEPTH_TEST );
	glEnable( GL_LIGHTING );
#endif

#if	_DBG_IK_DRAW
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_LIGHTING );

	for( unsigned short i = 0 ; i < m_unNumIK ; i++ )
	{
		m_pIKArray[i].debugDraw();
	}

	glEnable( GL_DEPTH_TEST );
	glEnable( GL_LIGHTING );
#endif

#if	_DBG_TEXTURE_DRAW
	g_clsTextureList0.debugDraw();
#endif
}

//========================
// ff[^̉ep`
//========================
void cPMDModel::renderForShadow( void )
{
	if( !m_pvec3OrgPositionArray )	return;

	glEnableClientState( GL_VERTEX_ARRAY );

	glVertexPointer( 3, GL_FLOAT, 0, m_pvec3PositionArray );

//	glDrawElements( GL_TRIANGLES, m_ulNumIndices, GL_UNSIGNED_SHORT, m_pIndices );
	glDrawElements( GL_TRIANGLES, m_ulNumIndices, GL_UNSIGNED_INT,   m_pIndices );

	glDisableClientState( GL_VERTEX_ARRAY );
}

//====================
// ff[^̉
//====================
void cPMDModel::release( void )
{
	if( m_pvec3OrgPositionArray )
	{
		free( m_pvec3OrgPositionArray );
		m_pvec3OrgPositionArray = NULL;
	}

	if( m_pvec3OrgPositionArray0 )
	{
		free( m_pvec3OrgPositionArray0 );
		m_pvec3OrgPositionArray0 = NULL;
	}

	if( m_pvec3OrgNormalArray )
	{
		free( m_pvec3OrgNormalArray );
		m_pvec3OrgNormalArray = NULL;
	}

	if( m_puvOrgTexureUVArray )
	{
		free( m_puvOrgTexureUVArray );
		m_puvOrgTexureUVArray = NULL;
	}

	if( m_pOrgSkinInfoArray )
	{
		free( m_pOrgSkinInfoArray );
		m_pOrgSkinInfoArray = NULL;
	}

	if( m_pvec3PositionArray )
	{
		free( m_pvec3PositionArray );
		m_pvec3PositionArray = NULL;
	}

	if( m_pvec3NormalArray )
	{
		free( m_pvec3NormalArray );
		m_pvec3NormalArray = NULL;
	}

	if( m_pIndices )
	{
		free( m_pIndices );
		m_pIndices = NULL;
	}
	
	if (m_pTexInfo) {
		free (m_pTexInfo);
		m_pTexInfo = NULL;
	}

	if( m_pMaterials )
	{
		for( unsigned long i = 0 ; i < m_ulNumMaterials ; i++ )
		{
			if( m_pMaterials[i].uiTexID != 0xFFFFFFFF )
				m_clsTextureList0.releaseTexture( m_pMaterials[i].uiTexID );
			if( m_pMaterials[i].uiSphereID != 0xFFFFFFFF )
				m_clsTextureList1.releaseTexture( m_pMaterials[i].uiSphereID );
		}

		free( m_pMaterials );
		m_pMaterials = NULL;
	}

	if( m_pBoneArray )
	{
		delete [] m_pBoneArray;
		m_pBoneArray = NULL;
		m_pNeckBone = NULL;
	}

	if( m_pIKArray )
	{
		delete [] m_pIKArray;
		m_pIKArray = NULL;
	}

	if( m_pFaceArray )
	{
		delete [] m_pFaceArray;
		m_pFaceArray = NULL;
	}

	if( m_pConstraintArray )
	{
		delete [] m_pConstraintArray;
		m_pConstraintArray = NULL;
		m_ulConstraintNum = 0;
	}

	if( m_pRigidBodyArray )
	{
		delete [] m_pRigidBodyArray;
		m_pRigidBodyArray = NULL;
		m_ulRigidBodyNum = 0;
	}
}
