//***********
// PMDf
//***********

#ifndef	_PMDMODEL_H_
#define	_PMDMODEL_H_

#include	"PMDTypes.h"
#include	"PMDBone.h"
#include	"PMDIK.h"
#include	"PMDFace.h"
#include	"PMDRigidBody.h"
#include	"PMDConstraint.h"
#include	"MotionPlayer.h"

#include	"PMXTypes.h"
#include	"TextureList.h"


void Init_OpenGL_ExtFunc (void); // OpenGL ext@\̏


class cPMDModel
{
	private :
		char			m_szModelName[256];	// f

		bool			m_bPmx;				// PMXȂtrue
		uchar			m_nExByte[8];		// PMX:f[^  PMX2.0 8 ŌŒ

		unsigned long	m_ulNumVertices;	// _

		Vector3			*m_pvec3OrgPositionArray;	// Wz cMotionPlayer::update()ōXVĂ܂
		Vector3			*m_pvec3OrgPositionArray0;	// Wz:PMXp PMDłbase\Ōɖ߂邪APMXłbase\̂ŁAfǂݍݎ̍W̃Rs[ہXƂĂ
		Vector3			*m_pvec3OrgNormalArray;		// @z
		TexUV			*m_puvOrgTexureUVArray;		// eNX`Wz

		struct SkinInfo
		{
			char	nWeightType;	// PMX:EFCg^
			float	fWeight [4];	// EFCgl: PMDł͂PAPMXł͂Sɑ
			long	unBoneNo[4];	// {[ԍ: PMDłunsigned short͈̔, PMXłlong͈̔(-1͔Qƒl)
		};
		SkinInfo		*m_pOrgSkinInfoArray;

		Vector3			*m_pvec3PositionArray;
		Vector3			*m_pvec3NormalArray;

		unsigned long	m_ulNumIndices;		// _CfbNX
		unsigned long	*m_pIndices;		// _CfbNXz

		unsigned long	m_ulNumTexture;				// PMX:eLX`

		struct TexInfo
		{
			char		m_szFileName[512];	// PMX:eLX`Et@C̃pX
		};
		TexInfo			*m_pTexInfo;

		struct Material
		{
			Color4			col4Diffuse,
							col4Specular,
							col4Ambient;
			float			fShininess;

			unsigned long	ulNumIndices;
			unsigned int	uiTexID;		// eNX`ID
			unsigned int	uiSphereID;		// XtBA}bvID
//			bool			bSphereMap;		// XtBA}bv邩ǂ: PMDp
			char			nSphereMode;	// XtBA[h 0: 1:Z(sph) 2:Z(spa) 3:TueNX`(ǉUV1x,yUVQƂĒʏeNX``s)
			uchar			cbFlags;		// `tO(8bit)
		};
		unsigned long	m_ulNumMaterials;	// }eA
		Material		*m_pMaterials;		// }eAz

		cTextureList	m_clsTextureList0; // eNX`jbg0p
		cTextureList	m_clsTextureList1; // eNX`jbg1p

		unsigned long	m_unNumBones;			// {[: PMDłunsigned short͈̔, PMXłunsigned long͈̔
		long			m_nMaxBoneTransLevel;	// {[̍őό`Kw
		cPMDBone		*m_pBoneArray;			// {[z

		cPMDBone		*m_pNeckBone;		// ̃{[
		bool			m_bLookAt;			// ^[Qbg֌邩ǂ

		unsigned short	m_unNumIK;			// IK
		cPMDIK			*m_pIKArray;		// IKz

		unsigned short	m_unNumFaces;		// \
		cPMDFace		*m_pFaceArray;		// \z

		unsigned long	m_ulRigidBodyNum;	// ̐
		cPMDRigidBody	*m_pRigidBodyArray;	// ̔z

		unsigned long	m_ulConstraintNum;	// RXgCg
		cPMDConstraint	*m_pConstraintArray;// RXgCgz

		cMotionPlayer	m_clMotionPlayer;


		bool isSphereMapTexName( const char *szTextureName, bool bAdd );

	public :
		cPMDModel( void );
		~cPMDModel( void );

		bool load( const char *szFilePath );
		bool initializePMD ( unsigned char *pData, unsigned long ulDataSize );
		bool initializePMX ( unsigned char *pData, unsigned long ulDataSize );

		unsigned char * copyPmxText( unsigned char *pData, char * lpszTextBuff, size_t nTextBuffSize );
		long getPmxBoneIndex(void *pvData);
		long getPmxTexIndex (void *pvData);
		long getPmxVtxIndex (void *pvData);
		long getPmxRbIndex  (void *pvData);

		cPMDBone *getBoneByName( const char *szBoneName );
		cPMDFace *getFaceByName( const char *szFaceName );

		void setMotion( cVMDMotion *pVMDMotion, bool bLoop = false, float fInterpolateFrame = 0.0f );
		void resetRigidBodyPos( void );

		bool updateMotion           ( float fElapsedFrame ); // ZÕ{[ό`
		bool updateMotionAfterBullet( float fElapsedFrame ); // Z̃{[ό`

		void updateNeckBone( const Vector3 *pvec3LookTarget, float fLimitXD = -20.0f, float fLimitXU = 45.0f, float fLimitY = 80.0f );
		void updateSkinning( void );

		void render( void );
		void renderForShadow( void );

		void release( void );

		inline void toggleLookAtFlag( void ){ m_bLookAt = !m_bLookAt; } 
		inline void setLookAtFlag( bool bFlag ){ m_bLookAt = bFlag; } 

		inline const char *getModelName( void ){ return m_szModelName; } 

	friend class cMotionPlayer;
};

#endif	// _PMDMODEL_H_
