//***************
// VMD[V
//***************

#include	<stdio.h>
#include	<stdlib.h>
#include	<malloc.h>
#include	<string.h>

#ifdef	_WIN32
#include	<windows.h>
#include	<locale.h>
#endif

#include	"VMDMotion.h"


//------------------------------
// {[L[t[\[gpr֐
//------------------------------
static int boneCompareFunc( const void *pA, const void *pB )
{
	return (int)(((BoneKeyFrame *)pA)->fFrameNo - ((BoneKeyFrame *)pB)->fFrameNo);
}

//------------------------------
// \L[t[\[gpr֐
//------------------------------
static int faceCompareFunc( const void *pA, const void *pB )
{
	return (int)(((FaceKeyFrame *)pA)->fFrameNo - ((FaceKeyFrame *)pB)->fFrameNo);
}

//================
// RXgN^
//================
cVMDMotion::cVMDMotion( void ) : m_pMotionDataList( NULL ), m_pFaceDataList( NULL ), m_pDefFaceData(NULL)
{
}

//==============
// fXgN^
//==============
cVMDMotion::~cVMDMotion( void )
{
	release();
	if (m_pDefFaceData) {
		free( m_pDefFaceData );
	}
}

//====================
// ftHg\t@C̓ǂݍ
//====================
bool cVMDMotion::loadDefFace( void )
{
	FILE	*pFile;
	fpos_t	fposFileSize;

	m_ulNumDefFace = 0;

	pFile = fopen( "default_face.txt", "rb" );
	if( !pFile )	return false;	// t@CJȂ

	// t@CTCY擾
	fseek( pFile, 0, SEEK_END );
	fgetpos( pFile, &fposFileSize );

	// m
	m_pDefFaceData = (unsigned char *)malloc( (size_t)fposFileSize + 1 );
	m_pDefFaceData[fposFileSize] = 0;

	// ǂݍ
	fseek( pFile, 0, SEEK_SET );
	fread( m_pDefFaceData, 1, (size_t)fposFileSize, pFile );

	fclose( pFile );

	// default\f[^
	unsigned char c, c0 = 0, *pSrc = m_pDefFaceData, *pDst = m_pDefFaceData;
	while (c = *pSrc++) {
		if (c == '\n') { // sR[h
			*pDst++ = '\0';
			if (c0) { // \鎞
				m_ulNumDefFace++;
				c0 = 0;
			}
		} else if (c >= ' ') {
			*pDst++ = c;
			c0 = c; // \
		}
	}
	*pDst = '\0';

	m_ulNumFaceNodes = 0;
	pSrc = m_pDefFaceData;
	for( unsigned long i = 0 ; i < m_ulNumDefFace ; i++ )
	{
		// VKm[hǉ
		FaceDataList	*pNew = new FaceDataList;

		strncpy( pNew->szFaceName, (const char *)pSrc, 15 );	pNew->szFaceName[15] = '\0';
		pNew->ulNumKeyFrames = 1;
		pNew->pKeyFrames = new FaceKeyFrame[1];
		pNew->pKeyFrames[0].fFrameNo = 0.0; // ŏ̃t[Kp
		pNew->pKeyFrames[0].fRate    = 1.0; // 1.0ɂ

		pNew->pNext = m_pFaceDataList;
		m_pFaceDataList = pNew;

		m_ulNumFaceNodes++;

		while (*pSrc++) // '\0'܂œǂݔ΂
			;
	}

#if 0
	wchar_t szMsg[256];
	wsprintf(szMsg, L"m_ulNumDefFace = %d, m_ulNumFaceNodes = %d", m_ulNumDefFace, m_ulNumFaceNodes);
	MessageBox(NULL, szMsg, L"cVMDMotion", MB_OK);
#endif

	return true;
}

//====================
// t@C̓ǂݍ
//====================
bool cVMDMotion::load( const char *szFilePath )
{
	FILE	*pFile;
	fpos_t	fposFileSize;
	unsigned char
			*pData;

	pFile = fopen( szFilePath, "rb" );
	if( !pFile )	return false;	// t@CJȂ

	// t@CTCY擾
	fseek( pFile, 0, SEEK_END );
	fgetpos( pFile, &fposFileSize );

	// m
	pData = (unsigned char *)malloc( (size_t)fposFileSize );

	// ǂݍ
	fseek( pFile, 0, SEEK_SET );
	fread( pData, 1, (size_t)fposFileSize, pFile );

	fclose( pFile );

	// [Vf[^
	bool	bRet = initialize( pData );

	free( pData );

	return bRet;
}

//==========================
// [Vf[^̏
//==========================
bool cVMDMotion::initialize( unsigned char *pData )
{
	release();

	// wb_̃`FbN
	VMD_Header	*pVMDHeader = (VMD_Header *)pData;
	if( strncmp( pVMDHeader->szHeader, "Vocaloid Motion Data 0002", 30 ) != 0 )
		return false;	// t@C`Ⴄ

	pData += sizeof( VMD_Header );

	//-----------------------------------------------------
	// {[̃L[t[擾
	unsigned long	ulNumBoneKeyFrames = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// ܂̓[Vf[^̃{[Ƃ̃L[t[JEg
	VMD_Motion		*pVMDMotion = (VMD_Motion *)pData;
	MotionDataList	*pMotTemp;

	m_fMaxFrame = 0.0f;
	for( unsigned long i = 0 ; i < ulNumBoneKeyFrames ; i++ )
	{
		if( m_fMaxFrame < (float)pVMDMotion->ulFrameNo )	m_fMaxFrame = (float)pVMDMotion->ulFrameNo;	// őt[XV

		pMotTemp = m_pMotionDataList;

		while( pMotTemp )
		{
			if( strncmp( pMotTemp->szBoneName, pVMDMotion->szBoneName, 15 ) == 0 )
			{
				// Xgɒǉς݂̃{[
				pMotTemp->ulNumKeyFrames++;
				break;
			}
			pMotTemp = pMotTemp->pNext;
		}

		if( !pMotTemp )
		{
			// XgɂȂꍇ͐VKm[hǉ
			MotionDataList	*pNew = new MotionDataList;

			strncpy( pNew->szBoneName, pVMDMotion->szBoneName, 15 );	pNew->szBoneName[15] = '\0';
			pNew->ulNumKeyFrames = 1;

			pNew->pNext = m_pMotionDataList;
			m_pMotionDataList = pNew;
		}
		
		pVMDMotion++;
	}

	// L[t[zm
	pMotTemp = m_pMotionDataList;
	m_ulNumMotionNodes = 0;
	while( pMotTemp )
	{
		pMotTemp->pKeyFrames = new BoneKeyFrame[pMotTemp->ulNumKeyFrames];
		pMotTemp->ulNumKeyFrames = 0;		// zCfbNXpɂ0ɂ
		pMotTemp = pMotTemp->pNext;

		m_ulNumMotionNodes++;
	}
	
	// {[ƂɃL[t[i[
	pVMDMotion = (VMD_Motion *)pData;

	for( unsigned long i = 0 ; i < ulNumBoneKeyFrames ; i++ )
	{
		pMotTemp = m_pMotionDataList;

		while( pMotTemp )
		{
			if( strncmp( pMotTemp->szBoneName, pVMDMotion->szBoneName, 15 ) == 0 )
			{
				BoneKeyFrame	*pKeyFrame = &(pMotTemp->pKeyFrames[pMotTemp->ulNumKeyFrames]);

				pKeyFrame->fFrameNo     = (float)pVMDMotion->ulFrameNo;
				pKeyFrame->vec3Position = pVMDMotion->vec3Position;
				QuaternionNormalize( &pKeyFrame->vec4Rotation, &pVMDMotion->vec4Rotation );

				pKeyFrame->clPosXInterBezier.initialize( pVMDMotion->cInterpolationX  [0], pVMDMotion->cInterpolationX  [4], pVMDMotion->cInterpolationX  [8], pVMDMotion->cInterpolationX  [12] );
				pKeyFrame->clPosYInterBezier.initialize( pVMDMotion->cInterpolationY  [0], pVMDMotion->cInterpolationY  [4], pVMDMotion->cInterpolationY  [8], pVMDMotion->cInterpolationY  [12] );
				pKeyFrame->clPosZInterBezier.initialize( pVMDMotion->cInterpolationZ  [0], pVMDMotion->cInterpolationZ  [4], pVMDMotion->cInterpolationZ  [8], pVMDMotion->cInterpolationZ  [12] );
				pKeyFrame->clRotInterBezier.initialize ( pVMDMotion->cInterpolationRot[0], pVMDMotion->cInterpolationRot[4], pVMDMotion->cInterpolationRot[8], pVMDMotion->cInterpolationRot[12] );

				pMotTemp->ulNumKeyFrames++;

				break;
			}
			pMotTemp = pMotTemp->pNext;
		}

		pVMDMotion++;
	}

	// L[t[zɃ\[g
	pMotTemp = m_pMotionDataList;

	while( pMotTemp )
	{
		qsort( pMotTemp->pKeyFrames, pMotTemp->ulNumKeyFrames, sizeof( BoneKeyFrame ), boneCompareFunc );
		pMotTemp = pMotTemp->pNext;
	}

#if 0
	// {[ƂɓL[t[mF
	pMotTemp = m_pMotionDataList;

	while( pMotTemp )
	{
		for( unsigned long i = 1 ; i < pMotTemp->ulNumKeyFrames ; i++ )
		{
			if (pMotTemp->pKeyFrames[i].fFrameNo == pMotTemp->pKeyFrames[i-1].fFrameNo) { // L[t[ԍ
				pMotTemp->pKeyFrames[i].fFrameNo = -1.0; // Iɖ̃L[t[ԍɂ
			}
		}
		pMotTemp = pMotTemp->pNext;
	}
#endif

	pData += sizeof( VMD_Motion ) * ulNumBoneKeyFrames;

	//-----------------------------------------------------
	// \̃L[t[擾
	unsigned long	ulNumFaceKeyFrames = *((unsigned long *)pData);
	pData += sizeof( unsigned long );

	// [Vf[^̕\Ƃ̃L[t[JEg
	VMD_Face		*pVMDFace = (VMD_Face *)pData;
	FaceDataList	*pFaceTemp;

#if 01
	// default\f[^荞܂
	if (m_pDefFaceData) {
		unsigned char *pTemp = m_pDefFaceData;
		for( unsigned long i = 0 ; i < m_ulNumDefFace ; i++ )
		{
			// VKm[hǉ
			FaceDataList	*pNew = new FaceDataList;

			strncpy( pNew->szFaceName, (const char *)pTemp, 15 );	pNew->szFaceName[15] = '\0';
			pNew->ulNumKeyFrames = 1;

			pNew->pNext = m_pFaceDataList;
			m_pFaceDataList = pNew;

			while (*pTemp++) // '\0'܂œǂݔ΂
				;
		}
	}
#endif

	for( unsigned long i = 0 ; i < ulNumFaceKeyFrames ; i++ )
	{
		if( m_fMaxFrame < (float)pVMDFace->ulFrameNo )	m_fMaxFrame = (float)pVMDFace->ulFrameNo;	// őt[XV

		pFaceTemp = m_pFaceDataList;

		while( pFaceTemp )
		{
			if( strncmp( pFaceTemp->szFaceName, pVMDFace->szFaceName, 15 ) == 0 )
			{
				// Xgɒǉς
				pFaceTemp->ulNumKeyFrames++;
				break;
			}
			pFaceTemp = pFaceTemp->pNext;
		}

		if( !pFaceTemp )
		{
			// XgɂȂꍇ͐VKm[hǉ
			FaceDataList	*pNew = new FaceDataList;

			strncpy( pNew->szFaceName, pVMDFace->szFaceName, 15 );	pNew->szFaceName[15] = '\0';
			pNew->ulNumKeyFrames = 1;

			pNew->pNext = m_pFaceDataList;
			m_pFaceDataList = pNew;
		}
		
		pVMDFace++;
	}

	// L[t[zm
	pFaceTemp = m_pFaceDataList;
	m_ulNumFaceNodes = 0;
	while( pFaceTemp )
	{
		pFaceTemp->pKeyFrames = new FaceKeyFrame[pFaceTemp->ulNumKeyFrames];
		pFaceTemp->ulNumKeyFrames = 0;		// zCfbNXpɂ0ɂ
		pFaceTemp = pFaceTemp->pNext;

		m_ulNumFaceNodes++;
	}

#if 01
	// default\f[^荞܂
	if (m_pDefFaceData) {
		unsigned char *pTemp = m_pDefFaceData;
		for( unsigned long i = 0 ; i < m_ulNumDefFace ; i++ )
		{
			pFaceTemp = m_pFaceDataList;

			while( pFaceTemp )
			{
				if( strncmp( pFaceTemp->szFaceName, (const char *)pTemp, 15 ) == 0 )
				{
					FaceKeyFrame	*pKeyFrame = &(pFaceTemp->pKeyFrames[pFaceTemp->ulNumKeyFrames]);

					pKeyFrame->fFrameNo = 0.0; // ŏ̃t[Kp
					pKeyFrame->fRate    = 1.0; // 1.0ɂ

					pFaceTemp->ulNumKeyFrames++;

					break;
				}
				pFaceTemp = pFaceTemp->pNext;
			}

			while (*pTemp++) // '\0'܂œǂݔ΂
				;
		}
	}
#endif

	// \ƂɃL[t[i[
	pVMDFace = (VMD_Face *)pData;

	for( unsigned long i = 0 ; i < ulNumFaceKeyFrames ; i++ )
	{
		pFaceTemp = m_pFaceDataList;

		while( pFaceTemp )
		{
			if( strncmp( pFaceTemp->szFaceName, pVMDFace->szFaceName, 15 ) == 0 )
			{
				FaceKeyFrame	*pKeyFrame = &(pFaceTemp->pKeyFrames[pFaceTemp->ulNumKeyFrames]);

				pKeyFrame->fFrameNo = (float)pVMDFace->ulFrameNo;
				pKeyFrame->fRate    =        pVMDFace->fFactor;

				pFaceTemp->ulNumKeyFrames++;

				break;
			}
			pFaceTemp = pFaceTemp->pNext;
		}
		
		pVMDFace++;
	}

	// L[t[zɃ\[g
	pFaceTemp = m_pFaceDataList;

	while( pFaceTemp )
	{
		qsort( pFaceTemp->pKeyFrames, pFaceTemp->ulNumKeyFrames, sizeof( FaceKeyFrame ), faceCompareFunc );
		pFaceTemp = pFaceTemp->pNext;
	}

	return true;
}

//======
// 
//======
void cVMDMotion::release( void )
{
	// [Vf[^̉
	MotionDataList	*pMotTemp = m_pMotionDataList,
					*pNextMotTemp;

	while( pMotTemp )
	{
		pNextMotTemp = pMotTemp->pNext;

		delete [] pMotTemp->pKeyFrames;

		delete pMotTemp;

		pMotTemp = pNextMotTemp;
	}

	m_pMotionDataList = NULL;

	// \f[^̉
	FaceDataList	*pFaceTemp = m_pFaceDataList,
					*pNextFaceTemp;

	while( pFaceTemp )
	{
		pNextFaceTemp = pFaceTemp->pNext;

		delete [] pFaceTemp->pKeyFrames;

		delete pFaceTemp;

		pFaceTemp = pNextFaceTemp;
	}

	m_pFaceDataList = NULL;
}
