//***************
// VMD[V
//***************

#ifndef		_VMDMOTION_H_
#define		_VMDMOTION_H_

#include	"PMDTypes.h"
#include	"PMDBone.h"
#include	"VMDTypes.h"
#include	"VMDBezier.h"

// {[Ώۂ̃L[t[f[^
struct BoneKeyFrame
{
	float	fFrameNo;		// t[ԍ

	Vector3	vec3Position;	// ʒu
	Vector4	vec4Rotation;	// ](NH[^jI)

	cVMDBezier	clPosXInterBezier;	// Xړ
	cVMDBezier	clPosYInterBezier;	// Yړ
	cVMDBezier	clPosZInterBezier;	// Zړ
	cVMDBezier	clRotInterBezier;	// ]
};

// {[Ƃ̃L[t[f[^̃Xg
struct MotionDataList
{
	char	szBoneName[16];			// {[

	unsigned long	ulNumKeyFrames;	// L[t[
	BoneKeyFrame	*pKeyFrames;	// L[t[f[^z

	MotionDataList	*pNext;
};

// \̃L[t[f[^
struct FaceKeyFrame
{
	float	fFrameNo;		// t[ԍ
	float	fRate;			// th
};

// \Ƃ̃L[t[f[^̃Xg
struct FaceDataList
{
	char	szFaceName[16];	// \

	unsigned long	ulNumKeyFrames;	// L[t[
	FaceKeyFrame	*pKeyFrames;	// L[t[f[^z

	FaceDataList	*pNext;
};


class cVMDMotion
{
	private :
		MotionDataList		*m_pMotionDataList;	// {[Ƃ̃L[t[f[^̃Xg
		unsigned long		m_ulNumMotionNodes;	// {[[Ṽm[h

		FaceDataList		*m_pFaceDataList;	// \Ƃ̃L[t[f[^̃Xg
		unsigned long		m_ulNumFaceNodes;	// \[Ṽm[h

		float				m_fMaxFrame;		// Ō̃t[ԍ

		unsigned char		*m_pDefFaceData;
		unsigned long		m_ulNumDefFace;


		bool initialize( unsigned char *pData );

	public :
		cVMDMotion( void );
		~cVMDMotion( void );

		bool loadDefFace( void ); // *.vmdɂ͖\"default_face.txt"荞
		bool load( const char *szFilePath );

		void release( void );

		inline MotionDataList *getMotionDataList( void ){ return m_pMotionDataList; }
		inline unsigned long getNumMotionNodes( void ){ return m_ulNumMotionNodes; }

		inline FaceDataList *getFaceDataList( void ){ return m_pFaceDataList; }
		inline unsigned long getNumFaceNodes( void ){ return m_ulNumFaceNodes; }

		inline float getMaxFrame( void ){ return m_fMaxFrame; }
};

#endif	// _VMDMOTION_H_
